/**
jq-scripts.js
MOTOROLA_CONFIDENTIAL_PROPRIETARY
------------------------------------------------------------------------------------------
                        Motorola Confidential Proprietary
                Copyright 2009 Motorola, Inc. All Rights Reserved.

Internal Revision History:

Modification Tracking

        Author                Date           CR         Description of Changes
-------------------------   ------------ ---------- ----------------------------------------
     andre.valongueiro      2009-03-24      41791       Initial Version
     atila.andrade          2009-06-01      42609       Refactoring and restructuring of code
     atila.andrade          2009-06-04      42646       Rework inspection
     atila.andrade          2009-06-09      42740       Latest link for operator user
     atila.andrade          2009-07-03      43447		Crash on Internet Explorer browser
     atila.andrade          2009-08-06      44051		Modem configuration with fields readonly
     atila.andrade          2009-08-11      44134		Modem Signals - table written dynamically
     atila.andrade          2009-08-19      44318		Modem Signals Upstream - multiple channels 
     atila.andrade          2009-09-09      43623       Enumeration Translation
     atila.andrade          2009-09-20      44891       Select idiom on interface - CR 43623 problem
     atila.andrade          2009-09-20      43624       Type validation
     atila.andrade          2009-09-24      44646       Unit attribute 
     atila.andrade          2009-09-29      44995       Max_cpe - static value on prompt table
     atila.andrade          2009-10-07      45112       PositiveInteger fields. ParseInt to base 10.
     atila.andrade          2009-10-07      45114       Login error messages (not translated)
     atila.andrade          2009-10-07      45137       Number of lines diferent of 2 and 4. 
     atila.andrade          2009-10-07      45185       Refresh on CM Configuration. 
     atila.andrade          2009-10-07      45188	    Timestamp - remove 'T' between date and time 
     atila.andrade          2009-10-16      45293	    Modem Configuration - Restarting message	
     atila.andrade          2009-10-30      45239       Legacy Initialization
     atila.andrade          2009-10-30      45554       Specifying error in xml tag
     atila.andrade          2009-11-11      45572       Latest links working correctly after correct
                                                        captures of menu click event.
	 andre.valongueiro      2009-11-20      45586       Scroll bar is not working correctly in Chorme and Firefox
	 andre.valongueiro      2009-11-20      45587       Scrool bar is displayed when Toolbox is open
     atila.andrade          2009-11-23      45701       EMTA and Gateway pages integrated	
     wms154-Mauro Silva     2010-02-04      45933       Extra fields at telephone call status tab 
                                                        were removed.
     wms154-Mauro Silva     2010-02-04      45934       The current language parameter was inserted
     wms154-Mauro Silva     2010-02-09      45938       Updating script based on sbv.4 files
     wbf367-Khalandar       2010-05-31      20807       Changed the number of default tags to 12 in 
                                                        function getXmlCallStatus
     wbf367-Khalandar       2010-06-01      22992       modified function getXmlCallFeaturesLine so that NCS specific 
                                                        message is displayed when protocol is NCS
**/

// =================================================================================================
// 
// GLOBAL VARIABLES
// 
// =================================================================================================
// Used to maintain just one AJAX request active on Page
_intervalCallAjax = null;
// Number of MTA lines used in Telephone -> Provisioning -> Call Features Tab
_qtyLines = 0;
// Array to save name of tags with enumerations values
_arrayEnumTranslate = null;
// Object map that specifies the content type for each element of a XML file. This object is 
// instantiated in the current HTML file.
_xmlTypeMAP = null;
// Array of xml file names with getting problems
_arrayXmlGettingError = new Array();

_serverAlert = 0;//dino@2010.10.28

// CBN Global Variables
var _Token = "";
var _userCookie = "none";
var _BandMode = 4;
var _NaptMode = 3;
var _UsbMode = 2;
var _CmProvisionMode = "IPv4";
var _GwProvisionMode = "IPv4";
var _PlatformType = "";
var _GwIpStack = "IPv6";
var _HpavMode = 0;
var _CustomerId = "CBN";
var _ConfigDisableWIFI = 0;
var _BuildTime = "";
var _MsoControlAllWifi24 = 0;;
var _MsoControlAllWifi5 = 0;
var _DsLite = 0;
var _PCP = 0;
// "Thread control". Used for syncronize the script functions 
run = {};
run.load = null;

// =================================================================================================
// 
// CONSTANTS
// 
// =================================================================================================
COOKIE_SEPARATOR      = '*';
DELAY_SHOW_MESSAGES   = 1000;
DELAY_SHOW_SLIDE      = 1000;
DELAY_REQUEST_SLOW    = 30000;
DELAY_REQUEST_REGULAR = 10000;
FULL_OPACITY           = 1.0;
HALF_OPACITY          = 0.4;
LOG_QTY_ENTRIES_LIMIT = 200;
ROOT_PAGE             = 'index.html';
LOGIN_SERVER_PATH     = '/login/Login.txt';
LOGOUT_SERVER_PATH    = '/login/Logout.txt';
ERROR_XML_DATATYPE    = 'error_data_type'; // PROMPT TABLE ID
ERROR_XML_TRANSLATE   = 'error_translate'; // PROMPT TABLE ID
UNDEFINED_TYPE        = "undefined";
// Regular Expressions 
DATE_REGULAR_EXPRESSION = /^(19|20)?\d{2}-((0?[1-9]|1[0-2])-(0?[1-9]|[12]\d)|(0?[13-9]|1[0-2])-30|(0?[13578]|1[02])-31)$/;
TIME_REGULAR_EXPRESSION = /^([0-1]?[0-9]|2[0-3]):[0-5]\d:[0-5]\d$/;
DATE_TIME_REGULAR_EXPRESSION            = /^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}$/;
DECIMAL_REGULAR_EXPRESSION              = /^[+-]?(\d*\.)?\d+$/;
INTEGER_REGULAR_EXPRESSION              = /^[+-]?\d+$/;
NON_NEGATIVE_INTEGER_REGULAR_EXPRESSION = /^\d+$/;
IPV4_ADDRESS_REGULAR_EXPRESSION = /^((25[0-5]|2[0-4]\d|[0-1]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[0-1]?\d\d?)$/;
IPV6_ADDRESS_REGULAR_EXPRESSION = /^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/;
FQDN_REGULAR_EXPRESSION = /^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$/;
WIFI_SSID_REGULAR_EXPRESSION = /^[\x20-\x7E]*$/;

// =================================================================================================
// 
// MAIN SCRIPT
// 
// =================================================================================================

$(function() {
    
	loadGlobalVar();
    // common-script.js - Load the application config and initialize the site.
    loadApp();  
    // latest-links.js - Set the latest links by section (Modem, Telephone, Battery and Gateway) 
    hide_latestlist();
    // latest-links.js - hide the empty link.
    latestLink();
    // Advanced User content
    advancedUserContent();
    // User Login
    accessUser();
    // Language operations - choose a idiom.
    languageOperations();
    // Table style - listing
    showTableStyle();
    // Table Selection
    selectTable();
    // Frequency Plan Select Menu
    selectMenuFrequencyPlan();
    // Select MTA Line Number in Telephone Provisioning > Call Features Tab
    //selectPhoneLine();
    // Tooltip Enable DHCP - Modem Configuration
    tooltipDHCPModemConfiguration();
    // GET Login to server
    sendGETUserLogin();
    // POST Cable Modem Configuration to server
    //sendPOSTModemConfiguration(); //@@Smile remove it because it is useless. 2011.12.27
    
}); // Close main function $(function())

// =================================================================================================
// 
// FUNCTIONS FOR LOAD HTML TABLES
// 
// =================================================================================================

function loadGlobalVar()
{
  $.ajax({
        type:"POST",
        url:"xml/GlobalSettings.xml",
        dataType:"xml",
		async:false,
        error:function(xmlResponse) { 
			// Show a message error on top page. Hide or opacity the content of the page.
            showErrorMessage(sField);
		},
        success:function(xmlResponse) {
			_Token = $(xmlResponse).find('Token').text();
			_userCookie = $(xmlResponse).find('UserLevel').text();
			_BandMode = $(xmlResponse).find('BandMode').text();
			_NaptMode = $(xmlResponse).find('NaptMode').text();
			_UsbMode = $(xmlResponse).find('UsbMode').text();
			_CmProvisionMode = $(xmlResponse).find('CmProvisionMode').text();
			_GwProvisionMode = $(xmlResponse).find('GwProvisionMode').text();
			_PlatformType = $(xmlResponse).find('PlatformType').text();
			_GwIpStack = $(xmlResponse).find('GwIpStack').text();
			_HpavMode = $(xmlResponse).find('HpavMode').text();
			_CustomerId = $(xmlResponse).find('CustomerId').text();
			_ConfigDisableWIFI = $(xmlResponse).find('ConfigDisableWIFI').text();
			_BuildTime = $(xmlResponse).find('BuildTime').text();
			_MsoControlAllWifi24 = $(xmlResponse).find('MsoControlAllWifi24').text();
			_MsoControlAllWifi5 = $(xmlResponse).find('MsoControlAllWifi5').text();
			_DsLite = $(xmlResponse).find('DsLite').text();
			_PCP = $(xmlResponse).find('PortControl').text();
        }
    });
}

function translateTableHeads() {
    var cookieIdiom = readCookie('prefIdiom');
	if (cookieIdiom) {
		// (switch-lang.js) Set the idiom preference of the user
		setLanguage(cookieIdiom);		
	} else {
		// (switch-lang.js) Set the default idiom
		setLanguage( $('#switch img').attr('src') + '*' + $('#switch img').attr('alt') + '*' + 
                     $('#switch img').attr('id') );
	}
};

// Verify if there is a user cookie and modify the xml to load and show in the page
function loadCallStatusTable() {
    var sHtmlLoad = ' #t-tel-call-status ';
    var sFile =  'xml/MtaLineStatus.xml';
    var pNode = 'line_status';
    
    // Check if the operator user is logged. 
    // This information specifies which XML file should be loaded
    if (_userCookie != "none") {
        sHtmlLoad = ' #t-tel-call-status-ncs-sip ';
        sFile = 'xml/LineCallStatus.xml'; 
        pNode = 'line_call_status';
        loadEnumTagsFromFile('LineCallStatus');
    }
    else
    {
        loadEnumTagsFromFile('MtaLineStatus');
    }

    $('#box-call-info').load('tl_call_tables.html' + sHtmlLoad,null, 
    function() {
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
        translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad ,sHtmlLoad,getXmlCallStatus,DELAY_REQUEST_REGULAR);
    });
};

/// <summary>
/// Load the html table and the XML file 
/// </summary>
///
/// <param name="sHtmlLoad">Target id used on 'tl_call_tables.html' file.</param>
/// <param name="sFile">XML name to load.</param>
/// <param name="pNode">Initial node access by parser xml.</param>
function loadCallQosHistoryTable(sHtmlLoad, sFile, pNode) {
    $('#box-call-info').load('tl_call_tables.html ' + sHtmlLoad,null, 
    function(){
        // Translate Tables <thead> tags
        translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value span",getXmlList,DELAY_REQUEST_SLOW);
    });
};

/// <summary>
/// Load the html table and the XML file 
/// </summary>
///
/// <param name="sFile">XML name to load.</param>
/// <param name="pNode">Initial node access by parser xml.</param>
/// <param name="sHtmlLoad">Target id used on 'cm_signal_tables.html' file.</param>
/// <param name="container">Local where will be written the sHtmlLoad content.</param>
/// <param name="func">Function that will be performed after of the request.</param>
function loadCMSignalsTable(sFile, pNode, sHtmlLoad, container, func) {
    $(container).load('cm_signal_tables.html ' + sHtmlLoad,null, 
    function(){
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
        translateTableHeads();
        multiAjaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value",func,
                     DELAY_REQUEST_REGULAR);
    });
}

function loadCMConnectionTable(sFile, pNode, sHtmlLoad, container, func) {
    $(container).load('cm_connection_tables.html ' + sHtmlLoad,null, 
    function(){
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
        translateTableHeads();
        multiAjaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value",func,
                     DELAY_REQUEST_REGULAR);
    });
} 
/// <summary>
/// Load the html table and the XML file for Cable Modem Log Page
/// </summary>
///
/// <param name="sHtmlLoad">Target id used on 'modem_logs_table.html' file.</param>
/// <param name="sFile">XML name to load.</param>
/// <param name="pNode">Initial node access by parser xml.</param>
/// <param name="htmlTableName">html table name to be loaded.</param>
function loadLogsTable(sHtmlLoad, sFile, pNode, htmlTableName) 
{
    $('.div-table').load(htmlTableName + ' ' + sHtmlLoad,null,
    function()
    {
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
        translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value span",getXmlList,DELAY_REQUEST_SLOW);
    });
}

function LoadMTACallHistoryTable(){
    var sHtmlTag = '.div-table';
    var sHtmlLoad = '#t-tel-call-history';
    var sFile = 'xml/MtaCallHistory.xml';
    var pNode = 'call_history';
    
    
    $(sHtmlTag).load('telephone_callhistory_table.html ' + sHtmlLoad,null, 
    function(){
        // Format Tables
    showTableStyle();
        // Translate Tables <thead> tags
		translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value span",getCallHistoryList,-1);

    });
}

// Verify if there is a user cookie and modify the xml to load and show in the page
function loadMTALogsTable(){
    var sHtmlLoad = '#t-tel-logs';
    var sFile = 'xml/MtaLogs.xml';
    var pNode = 'pk_log';
    var sHtmlTag = null;
    loadEnumTagsFromFile('MtaLogs');
    
    if (_userCookie != "none") {
	    $('.div-table,.table-logs-name').remove();
        $('#tabs').show();
        sHtmlTag = '#box-telephone-logs';
    }
    else
    {
        sHtmlTag = '.div-table';
    }
    
    
    $(sHtmlTag).load('telephone_logs_table.html ' + sHtmlLoad,null, 
    function(){
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
		translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value span",getXmlList,DELAY_REQUEST_SLOW);
    });
}

// Set the xml to be loaded and the local that should be written the content
function loadMTASignalingLogsTable(){
    var sHtmlLoad = '#t-tel-signaling-logs';
    var sFile = 'xml/AdvSignalingLogs.xml';
    var pNode = 'signaling_log';
    sHtmlTag = '#box-telephone-logs';

    loadEnumTagsFromFile('AdvSignalingLogs');
    
    $(sHtmlTag).load('telephone_logs_table.html ' + sHtmlLoad,null, 
    function(){
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
		translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value span",getXmlTelephoneSignalingLog,
                DELAY_REQUEST_SLOW);
    });
}

/// <summary>
/// Load the html table and the XML file 
/// </summary>
///
/// <param name="sFile">XML name to load.</param>
/// <param name="pNode">Initial node access by parser xml.</param>
/// <param name="sHtmlLoad">Target id used on 'tl_provisioning_tables.html' file.</param>
/// <param name="func">Function that will be performed after of the request.</param>
function loadTLProvisioningTable(sHtmlLoad, sFile, pNode, func){
    $('#box-telephone-provisioning').load('tl_provisioning_tables.html ' + sHtmlLoad,null, 
    function(){
        // Format Tables
        showTableStyle();
        // Translate Tables <thead> tags
		translateTableHeads();
        ajaxReq(sFile,pNode,sHtmlLoad,sHtmlLoad + " .td-value span",func,DELAY_REQUEST_REGULAR);
    });
}


// =================================================================================================
// 
// AJAX REQUEST
// 
// =================================================================================================

// Load the config idioms file and show the page according to the current idiom
function loadContentPage()
{
    // If the gateway resource is available, show content with default language
    if (_deviceConfig && _deviceConfig.gateway && 0)
    {
        showDefaultLanguage();
    }
    // Load the language configuration file
    else
    {
        // Ajax request performed for all pages on site. Load LANG.XML
        $.ajax ({
            type:"POST",
            url:"config/LANG.xml",
            dataType:"xml",
            error:function(xmlResponse){
                // If the language configuration file can't be loaded, show content with default language
                showDefaultLanguage();
            },
            success:function(xmlResponse) {
                // Read the possible languages of the site
                var numberOfLang = readLanguages(xmlResponse);
                // if there is only one language, the information about lang won't be displayed
                var stopScriptExec = legacyInterfaceByLang(numberOfLang)

                if(stopScriptExec == true) return;
                else processContentToShow();
            }
        });
    }
}

// Show the content page with default language
function showDefaultLanguage()
{
    // considering number of lang equal to 0
    var stopScriptExec = legacyInterfaceByLang(0)

    if(stopScriptExec == true) return;
    else processContentToShow();
}

// Function to define footer and lan pulldown based on
// number of language identified
function legacyInterfaceByLang(numberOfLang)
{
    var stopNow = true;

    if (numberOfLang <= 1)
    {
        $('#idLanguage, #switch').hide();

        if (numberOfLang == 0)
        {
            if (!showContentWithDefaultLanguage())
            {
                $('#footer a').hide();

                // returning TRUE for representing the interruption of script processing
                return (true);
            }
            eraseCookie('prefIdiom');
        }
    }
    else
    {
        // Read cookie and set the current language
        cookieIdiom();
        // (switch-lang.js) Capture the change idiom event and update the content page based
        // on the new language selected
        chooseLanguage();
    }

    // returning FALSE. The script processing doesn't stop!
    return (false);
}

/*@@Smile 2011.12.06*/
function getXmlIndexInfo(xmlResponse, pNode, sField, sValue, sNewId)
{
		var cid = $(xmlResponse).find('cid').text();
		var reg = $(xmlResponse).find('register').text();
		var freq = $(xmlResponse).find('freq').text();
		var CheckPassword = $(xmlResponse).find('CheckPassword').text();
		
		var hidden_item = 0;
		
		$('#id-goto-frequency').val(freq);

		if(cid == "23" && reg != "done")
    { 
        $('#ds_item').show();
 		}
 		else
 		{
 				$('#ds_item').hide();
 				hidden_item = 1;
		}
  		
		var numberOfItens = $('#content ul li').length;	

		switch(numberOfItens - hidden_item)
		{
			case 1:
				$('#content ul').css('padding-left','320px');
			break;
			case 3:
				$('#content ul').css('padding-left','120px');
			break;
			case 2:
				$('#content ul').css('padding-left','220px');
			break;
		} 


   	if (CheckPassword == "1")
   	   $('#id_changepw_msg').show();
  
   	if (CheckPassword == "0")
   	   $('#id_changepw_msg').hide();
}
/*@@Smile 2012.01.31*/
function ReflashXmlInfo(xmlResponse, pNode, sField, sValue, sNewId)
{
		var cid = $(xmlResponse).find('cid').text();
		var reg = $(xmlResponse).find('register').text();
		
		var hidden_item = 0;

		if(cid == "23" && reg != "done")
    { 
        $('#ds_item').show();
 		}
 		else
 		{
 				$('#ds_item').hide();
 				hidden_item = 1;
		}
  		
		var numberOfItens = $('#content ul li').length;	

		switch(numberOfItens - hidden_item)
		{
			case 1:
				$('#content ul').css('padding-left','320px');
			break;
			case 3:
				$('#content ul').css('padding-left','120px');
			break;
			case 2:
				$('#content ul').css('padding-left','220px');
			break;
		} 
}

function processContentToShow()
{
    //'run.load' is the function called in the HTML files.
    if (run.load != null){
        var result = run.load();
        if (result === 'stopExecution!')
        {
            return false;
        }
    }
    // After the content site is entirely loaded set the main container to visible
    $('#container,.div-table').css('visibility','visible');
    $('#container,.div-table-1').css('visibility','visible');
}

/// <summary>
/// Request XML data of device useing AJAX. This xml files are used to show general 
/// information on site. This function is only used locally.
/// </summary>
///
/// <param name="url">Target url relative the xml path to downlod.</param>
/// <param name="pNode">Initial node access by parser xml.</param>
/// <param name="sField">Used to write the xml's tags names.</param>
/// <param name="sValue">Used to write the xml's content.</param>
/// <param name="func">Function that will be performed after of the request.</param>
function ajaxReqIntern(url,pNode,sField,sValue,func) {
	$.ajax({
        type:"POST",
        url:url,
        data:"",
        dataType:"xml",
        error:function(xmlResponse) { 
			// Show a message error on top page. Hide or opacity the content of the page.
            showErrorMessage(sField);
		},
        success:function(xmlResponse) {
            // Hide the message error on top page. Show or opacity back the content of the page.
            hideErrorMessage(sField);
            // Use the current/default idiom
            var sIdiomId = getCurrentLanguage();
            // Read Cookie For Language
            var cookieIdiom = readCookie('prefIdiom');
            
            // If there is 'prefIdiom' cookie split and store you values in some variables
            if (cookieIdiom) {
                var vAttributes = cookieIdiom.split(COOKIE_SEPARATOR);
                var sNewFlag = vAttributes[0];
                var sNewAlt = vAttributes[1];
                var sNewIdiom = vAttributes[1];
                var sNewId = vAttributes[2];
                
                // Put the 'prefIdiom' cookie data as the user language preferences
                $('#switch img').attr({
                    src:sNewFlag,
                    alt:sNewAlt,
                    title:'Current Language: ' + sNewIdiom,
                    id:sNewId
                });
                // Set the current idiom
                sIdiomId = sNewId;
            } 
            
            // Check content: Translate enumeration tag, convert duration type and 
            // makes type validation
            xmlResponse = xmlContentFiltering(xmlResponse);

            // Call function passed as a 'func' parameter in ajaxReq
            func(xmlResponse,pNode,sField,sValue,sIdiomId);
        }
    });
}

function ajaxReqWithData(url,pNode,sField,sValue,func,data) {
	$.ajax({
        type:"POST",
        url:url,
        data: data,
        dataType:"xml",
        error:function(xmlResponse) { 
			// Show a message error on top page. Hide or opacity the content of the page.
            showErrorMessage(sField);
		},
        success:function(xmlResponse) {
            // Hide the message error on top page. Show or opacity back the content of the page.
            hideErrorMessage(sField);
            // Use the current/default idiom
            var sIdiomId = getCurrentLanguage();
            // Read Cookie For Language
            var cookieIdiom = readCookie('prefIdiom');
            
            // If there is 'prefIdiom' cookie split and store you values in some variables
            if (cookieIdiom) {
                var vAttributes = cookieIdiom.split(COOKIE_SEPARATOR);
                var sNewFlag = vAttributes[0];
                var sNewAlt = vAttributes[1];
                var sNewIdiom = vAttributes[1];
                var sNewId = vAttributes[2];
                
                // Put the 'prefIdiom' cookie data as the user language preferences
                $('#switch img').attr({
                    src:sNewFlag,
                    alt:sNewAlt,
                    title:'Current Language: ' + sNewIdiom,
                    id:sNewId
                });
                // Set the current idiom
                sIdiomId = sNewId;
            } 
            
            // Check content: Translate enumeration tag, convert duration type and 
            // makes type validation
//            xmlResponse = xmlContentFiltering(xmlResponse);

            // Call function passed as a 'func' parameter in ajaxReq
            func(xmlResponse,pNode,sField,sValue,sIdiomId);
        }
    });
}

/// <summary>
/// Single request XML data of device. Allows execute only one ajax request by page. 
/// Use the function "ajaxReqIntern" to do the AJAX request.
/// </summary>
///
/// * use the same parameters of ajaxReqIntern function.
/// <param name="iDelay">Specify the time (period) beteween each request.</param>
function ajaxReq(url,pNode,sField,sValue,func,iDelay) {

    var funcAjaxRequest = function(){ ajaxReqIntern(url,pNode,sField,sValue,func) };
    
    if (_intervalCallAjax != null) {
        clearInterval(_intervalCallAjax);
    }
    
    funcAjaxRequest();
    
    if (iDelay != -1) {
        _intervalCallAjax = window.setInterval(funcAjaxRequest,iDelay);
    }
}

/// <summary>
/// Multiple request XML data of device. Enables execute several ajax request by page. 
/// Use the function "ajaxReqIntern" to do the AJAX request.
/// </summary>
///
/// * use the same parameters of ajaxReqIntern function.
/// <param name="iDelay">Specify the time (period) beteween each request.</param>
function multiAjaxReq(url,pNode,sField,sValue,func,iDelay) {
    var funcAjaxRequest = function(){ ajaxReqIntern(url,pNode,sField,sValue,func) };
    
    funcAjaxRequest();
    
    if (iDelay != -1) {
        _intervalCallAjax = window.setInterval(funcAjaxRequest,iDelay);
    }
}

// =================================================================================================
// 
// XML PARSERS
// 
// =================================================================================================

/// <summary>
/// Functions used to receive and work with XML files returned by each one of the Ajax requests.
/// The functions below are often called as the 'func' parameters of these functions.
/// </summary>
///
/// <param name="xmlResponse">Initial node access by parser xml.</param>
/// <param name="pNode">Initial node access by parser xml.</param>
/// <param name="sField">Used to write the xml's tags names.</param>
/// <param name="sValue">Used to write the xml's content.</param>
/// <param name="sNewId">Used to define the current idiom of the user.</param>

/// * All parsers below use the same parameters

// General parse and Print XML Info
function getXmlInfo(xmlResponse,pNode,sField,sValue,sNewId) {
    var childrenNodes = $(xmlResponse).find(pNode)[0].childNodes;
    var iHtmlWriteCount = 0;
    var selectorField = $(sField);
    var selectorValue = $(sValue);
    var ProvisionMode= $(xmlResponse).find('provision_mode').text();    
    
    for(var i=0;i<childrenNodes.length;i++) {
        // Verify if the node is null or it has children
        if (!isValidTag(childrenNodes[i])) {
            // Do nothing
        }
        else {
            var sNodeName = childrenNodes[i].nodeName;
            var sContentTag = $(childrenNodes[i]).text();
            
            if(_CustomerId == "kdg" && sNodeName == "baseline_privacy")
                continue;
                
            selectorField.eq(iHtmlWriteCount)
			             .attr('id',sNodeName)
                         .html(getPromptTableValue(sNodeName))
                         .css('visibility','visible');
            
            selectorValue.eq(iHtmlWriteCount)
                         .html(sContentTag);
            
            iHtmlWriteCount++;
        }
    }
    
    if(ProvisionMode!="IPv4/IPv6")
    	$('#it-last').remove();
}

//CBN_s - Ken - 20100928 - set and get data with server by jquery
function ajaxSyncReq(url,data){
    try {
		
		var DataWithToken;

		if(typeof(data) == 'object'){
			DataWithToken = {
				'token':_Token
			};
		
			$.extend(DataWithToken,data);		
		}
		else
			DataWithToken = 'token=' + _Token + '&' + data;
		
        $.ajax({
            url: url,
            type: 'POST',
            async: false,
            data: DataWithToken,
			success: function(response) {
			
				_serverAlert = 0; //dino@2010.10.28

				//dino@2012.3.13
				if (response.match("refresh") && response.match("login")){
            		window.location.href = urlLocation() + '/' + ROOT_PAGE;
					return;
				}

				//Smile@2013.3.8
				if (response.match("opwnotmatch")){
					alert(getPromptTableValue('gw_common_errorstr_0019'));
					_serverAlert = 1; 
					return;
				} 
				
				// CBN - 20141224 - Gary add
				if (response.match("token")){
					_Token = response.split('=')[1];
					return;
				}
				
				if(jQuery.trim(response).length > 0){
					alert("Server: " + response);
					_serverAlert = 1; //dino@2010.10.28
				}
			},
            error: function(){
                showErrorMessage('#form-config');
            }
        });
    } 
    catch (e) {
        alert(e.message);
    }
}

function ajaxAsyncReq(url,data){
    try {

		var DataWithToken;

		if(typeof(data) == 'object'){
			DataWithToken = {
				'token':_Token
			};
		
			$.extend(DataWithToken,data);		
		}
		else
			DataWithToken = 'token=' + _Token + '&' + data;

        $.ajax({
            url: url,
            type: 'POST',
            async: true,
            data: DataWithToken,
			success: function(response) {
			
				_serverAlert = 0; //dino@2010.10.28

				//dino@2012.3.13
				if (response.match("refresh") && response.match("login")){
            		window.location.href = urlLocation() + '/' + ROOT_PAGE;
					return;
				}

				if(jQuery.trim(response).length > 0){
					alert("Server: " + response);
					_serverAlert = 1; //dino@2010.10.28
				}
			},
            error: function(){
                showErrorMessage('#form-config');
            }
        });
    } 
    catch (e) {
        alert(e.message);
    }
}

function verifyIP(IPvalue){
    errorString = "";
    
    var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
    var ipArray = IPvalue.match(ipPattern);
    
//    if (IPvalue == "0.0.0.0") 
//        errorString = errorString +  IPvalue + ' is a special IP address and cannot be used here.';
//    else 
        if (IPvalue == "255.255.255.255") 
            errorString = errorString + IPvalue + getPromptTableValue('gw_common_errorstr_0001');
    if (ipArray == null) 
        errorString = errorString + IPvalue + getPromptTableValue('gw_common_errorstr_0002');
    else {
        for (i = 1; i < 5; i++) {
            thisSegment = ipArray[i];
            if (thisSegment > 255) {
                errorString = errorString + IPvalue + getPromptTableValue('gw_common_errorstr_0002');
                i = 5;
            }
            if ((i == 1) && (thisSegment > 255)) {
                errorString = errorString + IPvalue + getPromptTableValue('gw_common_errorstr_0001');
                i = 5;
            }
        }
    }
    extensionLength = 3;
    if (errorString == "")
		return 0;
    else {
		alert(errorString);
		return -1;
	}
        
}

function verifyMAC(MACvalue){
	var errorString = "";
    var macPattern = /^([0-9a-f]{2}([:]|$)){6}$/i;
	var macArray = MACvalue.match(macPattern);
    if (macArray == null) 
        errorString = errorString + MACvalue + getPromptTableValue('gw_common_errorstr_0003');
		
    if (errorString == "")
		return 0;
    else {
		alert(errorString);
		return -1;
	}
}

function verifyPort(portvalue){
    if (portvalue >=0 && portvalue <=65535)
		return 0;
    else {
		alert(portvalue + getPromptTableValue("gw_common_errorstr_0005"));
		return -1;
	}
}

function verifyMask(maskvalue)
{
    //m[0] can be 128, 192, 224, 240, 248, 252, 254, 255
	//m[1] can be 128, 192, 224, 240, 248, 252, 254, 255 if m[0] is 255, else m[1] must be 0
	//m[2] can be 128, 192, 224, 240, 248, 252, 254, 255 if m[1] is 255, else m[2] must be 0
	//m[3] can be 128, 192, 224, 240, 248, 252, 254, 255 if m[2] is 255, else m[3] must be 0

	var errorString = '';
	var correct_range = {128:1,192:1,224:1,240:1,248:1,252:1,254:1,255:1,0:1};
	var m = maskvalue.split('.');

	for (var i = 0; i <= 3; i ++) {
		if (!(m[i] in correct_range)) {
			errorString = getPromptTableValue('gw_common_errorstr_0004');
			break;
		}
	}
	
	if ((m[0] == 0) || (m[0] != 255 && m[1] != 0) || (m[1] != 255 && m[2] != 0) || (m[2] != 255 && m[3] != 0)) {
		errorString = getPromptTableValue('gw_common_errorstr_0004');
	}
	
    if (errorString == "")
		return 0;
    else {
		alert(errorString);
		return -1;
	}
}

function getXmlMACFilteringInfo(xmlResponse, pNode, sField, sValue, sNewId){
	var maxInstance = $(xmlResponse).find('maxInstance').text();
	
	$('#MacFilterList').html('');
	$(xmlResponse).find('instance').each(function(){
	    var entry = $('<option value=""></option>');
		entry.text($(this).find("mac_addr").text());
		entry.val($(this).find("id").text());
		entry.appendTo('#MacFilterList');
	});
	$('#instanceCount').text(getPromptTableValue('gw_adv_option_0004') + $('#MacFilterList option').length + " / " + maxInstance);
}

function getXmlBasicDHCPInfo(xmlResponse, pNode, sField, sValue, sNewId){
	var Addr_start = $(xmlResponse).find('Addr_start').text();
	var NumberOfCpes = $(xmlResponse).find('NumberOfCpes').text();
	var Addr_end = parseInt(Addr_start) + parseInt(NumberOfCpes) - 1;

	//var LeaseTime = $(xmlResponse).find('LeaseTime').text();
	var LeaseDay = $(xmlResponse).find('LeaseDay').text();
	var LeaseHr = $(xmlResponse).find('LeaseHr').text();
	var LeaseMin = $(xmlResponse).find('LeaseMin').text();

	//var WinsAddress1 = $(xmlResponse).find('WinsAddress1').text();
	//var WinsAddress2 = $(xmlResponse).find('WinsAddress2').text();
	//var WinsAddress3 = $(xmlResponse).find('WinsAddress3').text();

	var DhcpServerEnable = $(xmlResponse).find('DhcpServerEnable').text();
	var LanIP_Pre = $(xmlResponse).find('LanIP_Pre').text();
	var Dhcpv6AddrSpool_start = $(xmlResponse).find('Dhcpv6AddrSpoolStart').text();
	var Dhcpv6AddrSpool_end = $(xmlResponse).find('Dhcpv6AddrSpoolEnd').text();
	var Dhcpv6AddrSpool_lifetime = $(xmlResponse).find('Dhcpv6AddrSpoolLifetime').text();

	var DhcpClientNumber = $(xmlResponse).find('DhcpClientNumber').text();		//Gary 20120913 Check DHCP client num
	if(DhcpClientNumber > 0)
		fillDhcpClientTable($(xmlResponse).find('DhcpClientTable'));

	$('#Addr_start').val(Addr_start);
	$('#NumberOfCpes').val(NumberOfCpes);
	$('#Addr_end').val(Addr_end);
	$('#LeaseDay').val(LeaseDay);
	$('#LeaseHr').val(LeaseHr);
	$('#LeaseMin').val(LeaseMin);

	//$('#LeaseTime').val(LeaseTime);

	//$('#WinsAddress1').text($('#WinsAddress1').text() + WinsAddress1);
	//$('#WinsAddress2').text($('#WinsAddress2').text() + WinsAddress2);
	//$('#WinsAddress3').text($('#WinsAddress3').text() + WinsAddress3);

		//dino@2010.10.13
		switch(DhcpServerEnable){
		case '0':
			$('#Off').attr("checked", true);
			$('#Off1').attr("checked", true);
			$('#dhcp-setting, #dhcp_clients, #static_assigned_dhcp_clients').hide();	// gary added at 20120721
			break;
		case '1':
			$('#On').attr("checked", true);
			$('#On1').attr("checked", true);
			$('#dhcp-setting, #dhcp_clients, #static_assigned_dhcp_clients').show();	// gary added at 20120721
			break;
		default:
			$('#On').attr("checked", true);
		}

	$('[name="LanIP_Pre"]').text(LanIP_Pre);

	$('#LeasedDhcp-tbody').find('#instance').each(function(index){$(this).remove()});
	//Static DHCP Table--------------------------------------------------
	//10.27 _1610
	$(xmlResponse).find('cmgw_DhcpSetting instance').each(function(index){

        if (pNode == "cmgw_DhcpSetting") {

            var entry = $('<tr id="instance">\
                                <td id="MacAddress"></td>\n\
                                <td id="LeasedIP"></td>\n\
            			<td><input id="Delete" value="0x01" type="checkbox" ></td>\n\
                              </tr>');

            var macAddress = $(this).find("MacAddress").text();
            var leasedIP = $(this).find("LeasedIP").text();
	    var id = $(this).find("id").text();

            entry.find('#MacAddress').text(macAddress );
            entry.find('#LeasedIP').text(leasedIP);
	    entry.find('#Delete').val(id);

	    entry.attr("value",id);
            entry.appendTo('#LeasedDhcp-tbody');
	}
	
	});
	//-----------------------------------------------------
	if(_GwProvisionMode=="IPv4")
	{
		$('#Dhcpv6AddrSpool_start').html("");
		$('#Dhcpv6AddrSpool_end').html("");
		$('#Dhcpv6AddrSpool_lifetime').html("");
	}
	else{
		$('#Dhcpv6AddrSpool_start').html(Dhcpv6AddrSpool_start);
		$('#Dhcpv6AddrSpool_end').html(Dhcpv6AddrSpool_end);
		if(Dhcpv6AddrSpool_lifetime != "0")
			$('#Dhcpv6AddrSpool_lifetime').html(convertSecondsToDurationString(Dhcpv6AddrSpool_lifetime));
		else
			$('#Dhcpv6AddrSpool_lifetime').html("");
	}
}

function getXmlAdvancedOptionInfo(xmlResponse, pNode, sField, sValue, sNewId){
	var maxInstance = $(xmlResponse).find('maxInstance').text();
	$('#options-table input:checkbox').each(function(index){
		var item = $(this).attr('id');
		if ($(xmlResponse).find(item).text() == 1){
			$(this).attr("checked", true);
		}
		else {
			$(this).attr("checked", false);
		}
	});
	
	$('#MacAddrList').html('');
	$(xmlResponse).find('nat_passthrough instance').each(function(index){
	    var entry = $('<option value=""></option>');
		entry.text($(this).find("mac_addr").text());
		entry.val($(this).find("id").text());
		entry.appendTo('#MacAddrList');
	});
	$('#instanceCount').text(getPromptTableValue('gw_adv_option_0004') + $('#MacAddrList option').length + " / " + maxInstance);

		//dino@2011.05.10
		var CustID = $(xmlResponse).find('CustID').text();
		if (CustID == "24"){ //FactoryCustomerId_Ono 24.
			var element = document.getElementById("passth_tb");
			element.parentNode.removeChild(element);			
		}

}

function getXmlWebFilterInfo(xmlResponse, pNode, sField, sValue, sNewId){
	$('#webfilter-tbody input:checkbox').each(function(index){
		var item = $(this).attr('id');
		if($(xmlResponse).find(item).text() == "1"){
			$(this).attr('checked',true);
		}
	});
	changeFirewallOption();		/* CBN - 20110906 */
	
  if(_CustomerId=="kdg") 
    $('#blockIpFragments-tr, #portScanDetection-tr , #synFloodDetection-tr').remove();	
}
/* CBN_S - 20110906 */
function changeFirewallOption()
{
	if($('#firewallProtection').attr("checked")==true){
		$('.firewall_option').removeAttr("disabled");
	}else{
		$('.firewall_option').removeAttr("checked");
		$('.firewall_option').attr("disabled", true);
	}
}
/* CBN_E - 20110906 */
function setAdvancedOptions(action){
    var sUrlServer = urlLocation() + '/setAdvancedOptions.html';
//    var parameters = {
//        'action': action,
//        'instance': $('#MacAddrList').val(),
//        'mac_addr': $('#mac_addr').val()
//    };
	if(action == "AddMacAddr")
		if(verifyMAC($('#mac_addr').val()) == -1) return;

	ajaxSyncReq(sUrlServer,"action=" +action+"&"+"instance=" +$('#MacAddrList').val()+"&"+$('input,select').serialize());
	location.reload();
}

function setMACFilter(action){
    var sUrlServer = urlLocation() + '/setMACFilter.html';
	
	if(action == "AddMacFilter")
		if(verifyMAC($('#NewMacFilter').val()) == -1) return;
	
    var parameters = {
        'action': action,
        'instance': $('#MacFilterList').val(),
        'mac_addr': $('#NewMacFilter').val()
    };
	ajaxSyncReq(sUrlServer,parameters);
	location.reload();
}

function setBasicDHCP(action){
	var sUrlServer = urlLocation() + '/setBasicDHCP.html';
	var data;
	var NumberOfCpes = $('#NumberOfCpes').val();
	
	if(action == 'AddPrimary' || action == 'AddSecondary' || action == 'AddTertiary')
		data = {'action': action ,'NewWinsAddress':$('#NewWinsAddress').val()};
	else if(action == 'setDHCP')
	{
		if($('#Addr_start').val() == '0' || $('#Addr_start').val() =='255')  // Smile add at 20121121
		{
			alert(getPromptTableValue('gw_bs_dhcp_001')+getPromptTableValue('gw_common_errorstr_0001'));
			return;
		}
		/* CBN - 20130904 - Gary - add for KD requirement */
		if(_CustomerId == "kdg"){
			if($('#Addr_end').val() <= '0' || $('#Addr_end').val() =='255')
			{
				alert(getPromptTableValue('gw_bs_dhcp_020')+getPromptTableValue('gw_common_errorstr_0001'));
				return;
			}
			else if(parseInt($('#Addr_end').val()) < parseInt($('#Addr_start').val()))
			{
				alert(getPromptTableValue('gw_common_errorstr_0022'));
				return;
			}
			else
				NumberOfCpes = parseInt($('#Addr_end').val()) - parseInt($('#Addr_start').val()) + 1;
		}
//dino@2010.10.14
		//data = {'action': action , 'DhcpServerEnable':$('input[name=DhcpServerEnable]:checked').val(), 'Addr_start':$('#Addr_start').val(),'NumberOfCpes':$('#NumberOfCpes').val(),'LeaseTime':$('#LeaseTime').val()};
		data = {'action': action , 'DhcpServerEnable':$('input[name=DhcpServerEnable]:checked').val(), 'Addr_start':$('#Addr_start').val(),'NumberOfCpes':NumberOfCpes,'LeaseDay':$('#LeaseDay').val(),'LeaseHr':$('#LeaseHr').val(),'LeaseMin':$('#LeaseMin').val()};
	}
	else if(action == 'RemoveWinsAddress')
		data = {'action': action ,'instance':$('#WinsAddressList').val()};
	else if(action == 'ClearAllWins')
		data = {'action': action};
	else if(action == 'reboot') // Smile add at 20130710
		data = {'action': action}; 
		
	if($('input[name=DhcpServerEnable]:checked').val() == 1)    // gary add at 20120721
		$('#dhcp-setting, #dhcp_clients, #static_assigned_dhcp_clients').show();
	else
		$('#dhcp-setting, #dhcp_clients, #static_assigned_dhcp_clients').hide();

	if(_CustomerId=="casa"){               // Smile add at 20130710
		$('#iddhcp, #tabs, #div-dhcpv6, #div-dhcpv4').hide();
		clearInterval(_intervalCallAjax);
		waitScreen("#waitScreen-div","basicDHCP.html",getPromptTableValue("gw_bs_setup_026"),90);
	}
	
	ajaxSyncReq(sUrlServer,data);
	//location.reload();
}

//dino@2010.10.18
//apply
//delete
//add_static
function setBasicDHCP1(action){
	
	var sUrlServer = urlLocation() + '/setBasicDHCP1.html';

	if(action == 'delete'){
		$('#LeasedDhcp-tbody').find('#Delete:checked').each(function(index){
			//good instance
			//ajaxSyncReq(sUrlServer,{'action':action, 'instance':$(this).val(), 'MacAddress':"0", 'LeasedIP':"0"});

			ajaxSyncReq(sUrlServer,{'action':action, 'instance':$(this).val(), 'MacAddress':$(this).val(), 'LeasedIP':$(this).val()});
		});
	}else if(action == "apply"){
		
		try{
			$('#LeasedDhcp-tbody').find('#instance').each(function(index){	//check value
				var MacAddress = $(this).find('#MacAddress').val();
				var LeasedIP = $(this).find('#LeasedIP').val();
				if(verifyMAC(MacAddress) == -1) throw "";
				if(verifyIP($('[name="LanIP_Pre"]').eq(0).text()+LeasedIP) == -1) throw "";
			});
		}catch(e){
			return;
		}
		
		$('#LeasedDhcp-tbody').find('#instance').each(function(index){	//apply
			ajaxSyncReq(sUrlServer,"action=" +action+"&"+"instance=" + $(this).attr("value") +"&" + $(this).find('input,select').serialize());
		});
		
	}else if(action == "add_static"){
		var MacAddress = $('#add_instance_table #InputMacAddress').val();
		var LeasedIP = $('#add_instance_table #InputLeasedIP').val();

		if(LeasedIP == "0" || LeasedIP == "255"){ // Smile add 20130104
			alert($('[name="LanIP_Pre"]').eq(0).text()+LeasedIP+getPromptTableValue('gw_common_errorstr_0001'));
			return; 
		}

		if(verifyMAC(MacAddress) == -1) return;
		if(verifyIP($('[name="LanIP_Pre"]').eq(0).text()+LeasedIP) == -1) return;

		ajaxSyncReq(sUrlServer,"action="+action+"&"+$('#add_instance_table').find('input,select').serialize() );
	}

//	}else if(action == 'add_static'){
//		var MacAddress = $('#add_instance_table #MacAddress').val();
//		var LeasedIP = $('#add_instance_table #LeasedIP').val();
//		
//		if(verifyMAC(MacAddress) == -1) return;
//		if(verifyIP("192.168.0."+LeasedIP) == -1) return;
//		//ajaxSyncReq(sUrlServer,"instance="+instance+"&action=" +action+"&"+$('#add_instance_table').find('input,select').serialize());
//		ajaxSyncReq(sUrlServer,"action=" +action+"&"+$('#add_instance_table').find('input,select').serialize());
//
//		$('#LeasedDhcp-tbody').find('#instance').each(function(index){	//apply
//			ajaxSyncReq(sUrlServer,"action=" +action+"&"+"instance=" + $(this).attr("value") +"&" + $(this).find('input,select').serialize());
//		});
//	}

	if (_serverAlert == 1)
		return;
		
	location.reload();
}



function setWebFilter(){
	var sUrlServer = urlLocation() + '/setWebFilter.html';
	ajaxSyncReq(sUrlServer,$('#webfilter-tbody input:checkbox').serialize());
	location.reload();
}

function setIPv6WebFilter(){
	var sUrlServer = urlLocation() + '/setIPv6WebFilter.html';
	ajaxSyncReq(sUrlServer,$('#webfilter-tbody input:checkbox').serialize());
	location.reload();
}

function waitScreen(divToInsert,url,message,second){
    var resettingMessage = '<span style="padding-left:10px; font-size:14px">'+message+'</span>&nbsp;' 
						+ '<span id="timeRemaining" class="bold"></span>';

    $(divToInsert).html(resettingMessage).css('width','750px');
	counterRedirect(second, url, '#timeRemaining');
}
//CBN_e - Ken - 20100928 - set and get data with server by jquery

// Parse and Print XML for HTML pages. Used on page header.
function getXmlHelpInfo(xmlResponse,pNode,sField,sValue,sNewId) {
    var childrenNodes = $(xmlResponse).find(pNode).find('*'); 
    var iHtmlWriteCount = 0;
	
	$('#help-data span').remove();
    
    for(var i=0;i<childrenNodes.length;i++) {
        // Verify if the node is null or it has children
        if ( !isValidTag(childrenNodes[i]) ) { 
            // Do nothing
        }
        else {
            var sNodeName = childrenNodes[i].nodeName;
            var sContentTag = $(childrenNodes[i]).text();
	    	if(_CustomerId=="mgm" && sNodeName=="wififirm_name")  //Gary add at 20120807 for TT256
				continue;
            $('<span class="left field" />')
                .appendTo(sField)
                .html(getPromptTableValue(sNodeName) + ': ')
                .css('visibility','visible');
            
            $('<span class="block value" />')
                .appendTo(sValue)
                .html(sContentTag);
            
            iHtmlWriteCount++;
        }
    }
}

// Parse and Print XML for HTML pages
function getXmlHelpContent(xmlResponse,pNode,sField,sValue) {
    
    var tableId            = document.getElementById("help-table");
    var helpHeaderEntry    = $(xmlResponse).find('help_header > help_header_entry');
    var helpTextTitleField = $(xmlResponse).find('help_text_title_field').text();
    var helpTextTitleValue = $(xmlResponse).find('help_text_title_value').text();
    var helpTextEntry      = $(xmlResponse).find('help_text_entry');
    var checklistItem      = $(xmlResponse).find('checklist_item');
    var helpCheckListTitle = $(xmlResponse).find('help_checklist_title');
    var tableCell, tableRow;
	
	// Remove old XML data from this page 
	$('#help-content p, #help-table tr:gt(0), #box-info h2, #box-info p').remove();	
                    
    // for each 'help_header_entry' found in XML create a <p> HTML tag and put the content
    $(helpHeaderEntry).each(
        function() {        
            $('<p/>').appendTo('#help-content').html( $(this).text() );            
        });
        
    $(tableId).find('th').eq(0).html(helpTextTitleField);
    $(tableId).find('th').eq(1).html(helpTextTitleValue);
    
    // for each 'help_text_entry' found execute de code below
    for (var i=0; i<helpTextEntry.length; i++) 
    {
       var helpTextField = $(helpTextEntry).eq(i).find('help_text_field').text();
       var helpTextValue = $(helpTextEntry).eq(i).find('help_text_value').text();
       
       // create a table row (<tr>) 
       tableRow = tableId.insertRow(tableId.rows.length);
       
       // create a table cell (<td>) inside the tableRow and put helpTextField content
       tableCell = tableRow.insertCell(tableRow.cells.length);
       $(tableCell).addClass('bold td-value').html(helpTextField);
       
       // create a table cell (<td>) inside the tableRow and put helpTextValue content
       tableCell = tableRow.insertCell(tableRow.cells.length);
       $(tableCell).html(helpTextValue);   
    };  
    
    // create <h2> HTML tag and put the title of the box
    $('<h2/>').appendTo('#box-info').html( $(helpCheckListTitle).text() );
    
    if(checklistItem.length != 0)
    {
		$('#box-info').addClass('box-info-border');
        // for each 'checklist_item' found in XML create a <p> HTML tag and put the content
        $(checklistItem).each(
           function() {
               $('<p/>').insertAfter('#box-info h2').html( $(this).text() );
           });  
    }
    else
    {
        $('#box-info').remove();
    }
      
};


// General parse and Print XML Info with list
function getXmlInfoWithList(xmlResponse,pNode,sField,sValue,sNewId) {
    var childrenNodes = $(xmlResponse).find(pNode)[0].childNodes;
    var iHtmlWriteCount = 0;
    
    var selectorField = $(sField + ' td strong');
    var selectorValue = $(sValue);
    
    var sLineBroken = '<br />';
    for(var i=0;i<childrenNodes.length;i++) {
        // Verify if the node is null or it has children
        if (childrenNodes[i].tagName != null)
        {
            var sNodeName = childrenNodes[i].nodeName;
            var sContentTag = '';
            if (childrenNodes[i].childNodes.length > 1) {
                
                var nodeMessage = childrenNodes[i].childNodes;
                for (var k=0; k<nodeMessage.length; k++)
                {
                    if (nodeMessage[k].tagName != null)
                    {
                        sContentTag += $(nodeMessage[k]).text() + sLineBroken;
                    }
                    else
                    {
                        // Do nothing
                    }
                }
            }
            else {
                sContentTag = $(childrenNodes[i]).text();
            }
            
            selectorField.eq(iHtmlWriteCount)
		                 .attr('id',sNodeName)
                         .html(getPromptTableValue(sNodeName))
                         .css('visibility','visible');
                         
            selectorValue.eq(iHtmlWriteCount)
                         .html( sContentTag );
            
            iHtmlWriteCount++;
        }
        else
        {
            // Do nothing
        }
    }
    $(sField + ' tr:gt('+(iHtmlWriteCount)+')').remove(); /* dynamic rows in info table */
}

/**
* Function for inserting info in the telephone_call page
* on the Call Status tab based on signaling protocol (NCS or SIP).
*
* @param xmlResponse - document 
* @param pNode       - node entry from list of telephone lines
* @param sField      - table id
* @param sValue      - table id + value 
* @param sNewId      - current language
*
* NOTE: By default the HTML (tl_call_tables.html) considers
*       the amount of tags (<TR>) for NCS protocol, in this
*       case 16 tags. Line number is not added in this set.
*       Otherwise the tags have to be removed.
*
*/
function getXmlCallStatus(xmlResponse,pNode,sField,sValue,sNewId) {

    var numDefaultTags = 12; // number of default tags without 
/* MOTO - cqvds00020807 - Khalandar */
                             // considering SIP or NCS
    
    var sHtmlId       = sField;
    var selectorField = null;

    // saving node 'line_call_status'
    var lineCallStatusNode = $(xmlResponse).find(pNode);
    
    // SIP Tag
    var registratioStateTag = lineCallStatusNode.find('registration_state').eq(0).text();
    
    // NCS Tags
    var rsipStatusTag       = lineCallStatusNode.find('rsip_status').eq(0).text();
    var requestedEventsTag  = lineCallStatusNode.find('requested_events').eq(0).text();
    var eventQueueTag       = lineCallStatusNode.find('event_queue').eq(0).text();    
    
    if (isContent(registratioStateTag))
    {
        protocol = 'sip';
    }
    else if (isContent(rsipStatusTag)     &&
             isContent(requestedEventsTag)&&
             isContent(eventQueueTag)      )
         {
            protocol = 'ncs';
         
         }
         else
         {
            // ATTENTION: unexpected situation
            protocol = 'na';
         }
    
    // Used to define the table header content
    var lineNumbers = $(xmlResponse).find(pNode).find('line_number');

    // Note: we have 16 tags of data but indexed form 0 to 17 because
    //       the first one is related to TR of table header. The tags
    //       of data are using the index from 1 to 17
    switch (protocol)
    {
        case 'sip':
        {
            var indexSIP = numDefaultTags+1;
            // removing tags <tr> from this index on
            $(sHtmlId + ' tr:gt('+ indexSIP +')').remove();
        }
        break;
        case 'na':
        {
            var indexNA = numDefaultTags-1;
            // removing tags <tr> from this index on
            $(sHtmlId + ' tr:gt('+ indexNA +')').remove();
        }
        break;
   }
   
    // String manipulation to get the id element
    if (sValue.search(".td-value") != -1)
    {
        sValue = sValue.substr(0,sValue.indexOf(" "));
        sValue += " .td-value";
    }
    else
    {
        sValue += " .td-value";
    }
	
    var lines = $(xmlResponse).find(pNode).find('*');
    var iSize = lines.length;
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    
    var resultLines = setNumberOfLines(iQtyNodes, lineNumbers, sHtmlId)
    
    if (resultLines)
    {
        // number of data discarding <line_number> tag
        var iNumData = (iSize / iQtyNodes) - 1;
        if (sField.search("td strong") == -1)
        {
            sField += " td strong";
        }
        selectorField = $(sField);
        for (var i=0;i<iNumData;i++)
        {
            var sNodeName = $(lines[i + 1])[0].nodeName;
            selectorField
                .eq(i)
                .attr('id',sNodeName)
                .html(getPromptTableValue(sNodeName));
        }

        iNumData++;
        for(var i=1;i<iSize;i++) 
        {
            var sContentTag = $(lines[i]).text();
            var sNodeName = $(lines[i])[0].nodeName;
            var iIndexTable = Math.ceil(i/iNumData);
            var iIndexPosition = (i - 1)%iNumData;
            
            $(sValue + iIndexTable + ' span').eq(iIndexPosition).html( sContentTag );
        }
    }
    else
    {
        // Do nothing
    }
};

// Parse and Print XML Info for telephone_call page
function getXmlLineProvisioning(xmlResponse,pNode,sField,sValue,sNewId) {
    var sHtmlId = sField;
	// store the type of signaling protocol (ncs,sip or na)
	var protocol = $(xmlResponse).find(pNode).find('signaling_protocol').eq(0).text();
	// Used to define the table header content
    var lineNumbers = $(xmlResponse).find(pNode).find('line_number');
    
    // if signaling protocol value is 'ncs'
	if (protocol == getPromptTableValue('ncs')) {
		// remove some tags <tr> of the table
		$(sHtmlId + ' tr:gt(10)').remove();
	}
			
    if (sField.search("td strong") == -1) {
        sField += " td strong";
    }
    if (sValue.search(".td-value") != -1) {
        sValue = sValue.substr(0,sValue.indexOf(" "));
        sValue += " .td-value";
    }
    else {
        sValue += " .td-value";
    }

    var lines = [];
	var rows = $(xmlResponse).find(pNode)[0].childNodes;
	for(var i=0;i<rows.length;i++){
		if(rows[i].nodeType==1 && rows[i].tagName){
			lines.push(rows[i]);
		}
	}
	//CBN_S 20130327 Blake modify for telephone_provisioning.html
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var iSize = lines.length;
    var resultLines = setNumberOfLines(iQtyNodes, lineNumbers, sHtmlId)
    
    if (resultLines)
    {
        //var iNumData = (iSize / iQtyNodes) - 1;
        var iNumData = iSize -1;
        for (var i=0;i<iNumData;i++) {
            var sNode = $(lines[i + 1])[0].nodeName;
            //alert(sNode);
            $(sField)
                .eq(i)
				.attr('id',sNode)
                .html(getPromptTableValue(sNode));
        }

        iNumData++;
        for(var j=0;j<iQtyNodes;j++){
        	var lines1 = [];
        	var rows1 = $(xmlResponse).find(pNode)[j].childNodes;
        	for(var n=0;n<rows1.length;n++){
				if(rows1[n].nodeType==1 && rows1[n].tagName){
					lines1.push(rows1[n]);
				}
			}
        	for(var i=1;i<iSize;i++) {
				var sContentTag = '';
				var sNodeName = lines1[i].nodeName;
				if(lines1[i].childNodes.length > 1){
					var nodeMessage = [];
					var rows2 = lines1[i].childNodes;
					for(var m=0;m<rows2.length;m++){
						if(rows2[m].nodeType==1 && rows2[m].tagName){
						nodeMessage.push(rows2[m]);
						}
					}
                	for (var k=0; k<nodeMessage.length; k++)
                	{
                    	if(k==0){
							sContentTag += '<b>';
							sContentTag += $(nodeMessage[k]).text();
							sContentTag += '</b>, ';
						}
						else if(k == nodeMessage.length-1){
							sContentTag += $(nodeMessage[k]).text();
						}
						else{
							sContentTag += $(nodeMessage[k]).text()+ ', ';
						}
                	}
				}
				else{
					sContentTag = $(lines1[i]).text();
				}
            	var iIndexTable = j+1;//Math.ceil(i/iNumData);
            	var iIndexPosition = (i - 1);//%iNumData;
            
            	/* CBN - Fix that line number shows in provisioning table */
            	//if(i==iNumData)
            	//	continue;
            
            	$(sValue + iIndexTable + ' span').eq(iIndexPosition).html( sContentTag );
        	}
        }
        $(sHtmlId + ' tr:gt('+(iNumData-1)+')').remove(); // CBN - dynamic rows of the provisioning table
		
    }
    else
    {
        // Do Nothing
    }
}

function getCallHistoryList(xmlResponse,pNode,sField,sValue,sNewId) {
    var callHistories = $(xmlResponse).find(pNode);
    var qtycallHistory = callHistories.length;
    
    $('#id-index-select option').remove();
    
    if(qtycallHistory == 0)
        $('#select-div').remove();

    for(var i=0; i<qtycallHistory; i++ ) {
    
      	var opt = '<option value="index'+(i+1)+'">'+(i+1)+'</option>';
      	$('#id-index-select').append(opt);
      	
        var childrenNodes = $(callHistories[i]).find("*");

        for(var j=0; j<childrenNodes.length; j++){ 
        	
            var sLineGuide = '<tr>';

            sLineGuide += '<td><strong class="dynamic">';
            if(j==0){
                sLineGuide += '<a name="index' + (i+1)+ '">'+(i+1)+'</a>';
            }
            sLineGuide += '</strong></td>';       	

            sLineGuide += '<td><strong class="dynamic">';
            var sNodeName = $(childrenNodes[j])[0].nodeName;
            sLineGuide += getPromptTableValue(sNodeName);
            sLineGuide += '</strong></td>';
            
            sLineGuide += '<td class="td-value"><span>';
            sLineGuide += $(childrenNodes[j]).text();
            sLineGuide += '</span></td>';
            
            sLineGuide += '</tr>';
            
            $(sField).append(sLineGuide);
        }
    }

}

// Parse and Print XML Info for dynamic lists (Log, history...)
function getXmlList(xmlResponse,pNode,sField,sValue,sNewId) {
    // Remove the old table's content
    $(sField).find("tr:gt(0)").remove('*');
    
    var resultCheck = checkFormationLog(xmlResponse, pNode, sField);
    
    if (resultCheck)
    {
        // Table's cells
        var nodes = $(xmlResponse).find(pNode).find('*');
        // Number of table's entries (lines)
        var iQtyEntries = $(xmlResponse).find(pNode).length;
        // Number of table's header. Used for tables that have more than one header
        var iQtyHeaders = $(sField).find("tr:gt(0)").length;
        // Number of table's cells
        var iQtyCells = nodes.length;
    
        // Number of table's Columns 
        var iNumParameters = iQtyCells / iQtyEntries;
        
        // Build a html table line
        var sLineGuide = '<tr>';
        for (var i=0;i<iNumParameters;i++) 
        {
            sLineGuide += '<td class="td-value"><span></span></td>';
        }
        sLineGuide += '</tr>';
        
        // Define a limit for log entries...
        if (iQtyEntries > LOG_QTY_ENTRIES_LIMIT)
        {
            iQtyEntries = LOG_QTY_ENTRIES_LIMIT;
            iQtyCells = iQtyEntries * iNumParameters;
        }
        
        // Number of table lines
        var iTableLines = iQtyEntries-iQtyHeaders;
        
        // Write the html table line builded 'iTableLines' times on page
        var selectorTable = $(sField);
        for (var i=0;i<iTableLines;i++) 
        {
            selectorTable.append(sLineGuide);
        }
        
        // Build a selector for all table's cell
        var selectorCell = $(sValue);
        for(var i=0;i<iQtyCells;i++) 
        {
            // Get the content xml tag
            var sContentTag = $(nodes[i]).text();
            // Set the content cell by index i
            selectorCell.eq(i).html( sContentTag );
        }
        // Style table
        showTableStyle();
    }
    else
    {
        // Do nothing
    }
}

// Address parser. Use the generic parser getXmlInfo 
function getXmlModemAddress(xmlResponse,pNode,sField,sValue,sNewId) {
    var xmlStruct = $(xmlResponse).find(pNode)[0];
    var usbIP = $(xmlStruct).find('usb_ip'); 
    var usbMAC = $(xmlStruct).find('usb_mac'); 
    
    // If there are the tags usb_ip AND usb_mac on XML, the table lines are showed
    if (usbIP.length != 0 && usbMAC.length != 0)
    {
        $(sField).find('.none').show();
    }
    // Set the correct sField value for getXmlInfo function
    sField = ' td strong';
    // Call the generic function for fill the table
    getXmlInfo(xmlResponse,pNode,sField,sValue,sNewId);
}

// KnownCpe parser
function getXmlKnownCpe(xmlResponse,pNode,sField,sValue,sNewId) {
    var maxCpeValue = $(xmlResponse).find('max_cpe').text();
    var ID_KNOWN_CPE = 'idKnowCPE';
    var ID_MAX = 'idMax';

    var htmlHeaderMaxCpe = getPromptTableValue(ID_KNOWN_CPE) + 
                           " ( " + 
                           getPromptTableValue(ID_MAX) +
                           " " + 
                           maxCpeValue + 
                           " )";
    $('#' + ID_KNOWN_CPE).html(htmlHeaderMaxCpe);
    getXmlList(xmlResponse,pNode,sField,sValue,sNewId);
}

// Parse and Print XML Info for modem_signals.html page.
function getXmlCMSignalDownstream(xmlResponse,pNode,sField,sValue,sNewId) {
    var lines = $(xmlResponse).find(pNode).find('*');
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var iSize = lines.length;
    var CustID = $(xmlResponse).find('cid').text();//Richard_Chen@2011/12/08 for kdg
    // Remove the old table (keep the header)
    $(sField + ' tr:gt(0)').remove();
    
    // If there is more than 8 downstream channels 
    if (!pNode.indexOf("downstream") && iQtyNodes > 8)
    {
        return;
    }
    
    if (iQtyNodes > 0)
    {
        var iQtyLines = (iSize / iQtyNodes);
        
        // Set a dynamic value to colspan value       
        $(sField + ' .colspan').each(function() { this.colSpan = iQtyNodes });
        
        // Build the table struct
        var sLineGuide = '<tr>';
        sLineGuide += '<td><strong class="dynamic" id="idLoading"></strong></td>';
        for (var i=0;i<iQtyNodes;i++) 
        {
            sLineGuide += '<td class="td-value' + (i + 1) + '"><span></span></td>';
        }
        sLineGuide += '</tr>';
        
        // Write the table struct
        for (var i=0;i<iQtyLines;i++) 
        {
            $(sField).append(sLineGuide);
            var sNode = $(lines[i])[0].nodeName;
//Richard_Chen@2011/12/08 for kdg Start
            if( (CustID == "23") && sNode == "power_level")
              sNode = "power_level_micro";
//Richard_Chen@2011/12/08 for kdg End            
            $(sField + " td strong")
                .eq(i)
				.attr('id',sNode)
                .html(getPromptTableValue(sNode));
        }

        for(var i=0;i<iSize;i++) 
        {
            var sContentTag = $(lines[i]).text();
            var iIndexTable = Math.ceil((i+1)/iQtyLines);
            var iIndexPosition = i%iQtyLines;
//Richard_Chen@2011/12/08 for kdg Start
            var sNode = $(lines[i])[0].nodeName;
            if( (CustID == "23") && sNode == "power_level")
            {  
              if(!isNaN(parseInt(sContentTag,10)))
                sContentTag = parseInt(sContentTag,10) + 60;
            }
//Richard_Chen@2011/12/08 for kdg End
            $(sValue + iIndexTable + ' span').eq(iIndexPosition).html( sContentTag );
        }
        showTableStyle();
    }
    else
    {
        // Do nothing
    }
}

 /**
 * Updates the content of the upstream section at Modem -> Signals. Write the struct  
 * 'upstream_channel' in upstream section. 
 *
 * @param pNode - upstream_channel 
 */
function getXmlCMSignalUpstream(xmlResponse,pNode,sField,sValue,sNewId) {
    var upstreamChannels = $(xmlResponse).find(pNode);
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var qtyUpstreamCh = upstreamChannels.length;
    var UPSTREAM_PROPERTIES = 7;
    var htmlIndexWrite = 0;
    var isFirstIteraction = true;
    var CustID = $(xmlResponse).find('cid').text();//Richard_Chen@2011/12/08 for kdg
    // Remove the old table (keep the header)
    $(sField + ' tr:gt(0)').remove();
    
    if (iQtyNodes > 0 && iQtyNodes <= 8)
    {
    
        // Build the table struct. The number of the columns  is the defined by 'qtyUpstreamCh'
        // HTML example
        // <tr>
        //      <td><strong class="dynamic" id="idLoading"></strong></td>
        //      <td class="td-value"><span></span></td>
        //      ...
        // </tr>
        var sLineGuide = '<tr>';
        sLineGuide += '<td><strong class="dynamic" id="idLoading"></strong></td>';
        for (var i=0;i<qtyUpstreamCh;i++) {
            sLineGuide += '<td class="td-value' + i + '"><span></span></td>';
        }
        sLineGuide += '</tr>';
        
        // Write the Lines
        for (var i=0;i<UPSTREAM_PROPERTIES;i++) 
        {
            $(sField).append(sLineGuide);
        }
        
        // Define the table width 
        $(sField + ' .colspan').each(function() { this.colSpan = iQtyNodes });
        
        // Update the field select
        sField += " td strong";
        for (var i=0;i<qtyUpstreamCh;i++) 
        {
            // Set the index count to 0. It's necessary to fill many columns
            htmlIndexWrite = 0;
            
            var childrenNodes = $(upstreamChannels[i]).find('*');
            var qtyModulations = $(upstreamChannels[i]).find('modulation').length;
            // The childrenNodes.length is decreased (-1) because the modulation elements are disregarded
            var iLastIndex = childrenNodes.length - 1;
            // Each modulation item has 3 tags
            iLastIndex -= qtyModulations * 3;
            
            if (iLastIndex >= 0)
            {
                for(var j=0;j<iLastIndex;j++) {
                    var sNodeName = $(childrenNodes[j])[0].nodeName;
                    var sContentTag = $(childrenNodes[j]).text();
//Richard_Chen@2011/12/08 for kdg Start
                    if( (CustID == "23") && sNodeName == "power_level")
                    {
                      if(!isNaN(parseInt(sContentTag,10)))
                        sContentTag = parseInt(sContentTag,10) + 60;
                      sNodeName = "power_level_micro";
                    }
//Richard_Chen@2011/12/08 for kdg End
                    // If is the first iteration to avoid redraw the first column...
                    if (isFirstIteraction)
                    {
                        $(sField)
                            .eq(htmlIndexWrite)
                            .attr('id',sNodeName)
                            .html(getPromptTableValue(sNodeName))
                            .css('visibility','visible');
                    }
                    $(sValue + i + ' span').eq(htmlIndexWrite).html( sContentTag );
                    htmlIndexWrite++;
                }
                
                // If is the first iteration to avoid redraw the first column...
                if (isFirstIteraction)
                {
                    // Writing modulations
                    sNodeName = $(childrenNodes[iLastIndex])[0].nodeName;
                    $(sField).eq(htmlIndexWrite)
                        .attr('id',sNodeName)
                        .html(getPromptTableValue(sNodeName))
                        .css('visibility','visible');
                }
                
                // Used to write the main colunm just one time
                isFirstIteraction = false;
                
                if (qtyModulations == 0)
                {
                    $(sValue + i + ' span')
                        .eq(htmlIndexWrite)
                        .html(getPromptTableValue(ERROR_XML_DATATYPE));
                }
                else
                {
                    sNodeName = $(childrenNodes[iLastIndex + 1])[0].nodeName
                    var sContentModulation = "";
                    var sLineBroken = '<br />';
                    
                    // Example of cell content
                    // [3] 64qam
                    // [4] 128qam
                    // [4] 128qam
                    // [4] 128qam
                    // ...
                    var modulations = $(upstreamChannels[i]).find(sNodeName).each(function(){
                        var modulation = $(this).find('*');
                        //CBN20110329 Roy fix duplicate upstream modulation type at WEB GUI for ONO
                        //var sFirstElement = '[' + $(modulation[0]).text() +'] ';
                        var sSecondElement = $(modulation[1]).text() + sLineBroken;
                        //sContentModulation += sFirstElement + ' ' + sSecondElement;
                        sContentModulation = sSecondElement;
                    });
                    $(sValue + i + ' span').eq(htmlIndexWrite).html(sContentModulation);
                }
            }
            else
            {
                // Do nothing
            }
        }
        showTableStyle();
    }
    else
    {
        // Do nothing
    }
}

function getXmlCMConnectionDownstream(xmlResponse,pNode,sField,sValue,sNewId) {
    var lines = $(xmlResponse).find(pNode).find('*');
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var iSize = lines.length;
    var CustID = $(xmlResponse).find('cid').text();//Richard_Chen@2011/12/08 for kdg
    // Remove the old table (keep the header)
    $(sField + ' tr:gt(1)').remove();
    
    // If there is more than 8 downstream channels 
    if (!pNode.indexOf("downstream") && iQtyNodes > 8)
    {
        return;
    }
    
    if (iQtyNodes > 0)
    {
        var iQtyLines = (iSize / iQtyNodes);
        
        for(var i=0;i<iQtyNodes;i++) 
        {
            var sLineGuide = '<tr>';
            sLineGuide += '<td class="td-value"><span>' + (i+1) + '</span></td>';
            for(var j=0;j<iQtyLines;j++)
            {
                var sNode = $(lines[i*iQtyLines+j])[0].nodeName; 
                var sContentTag = $(lines[i*iQtyLines+j]).text();
                if(sNode=="power_level")
                    sContentTag = parseInt(sContentTag,10)+60;
                if(sNode=="frequency")
                    sContentTag = parseInt(sContentTag,10) / 1000000;

                sLineGuide += '<td class="td-value"><span>'+sContentTag+'</span></td>';
            }
            sLineGuide += '</tr>';
            $(sField).append(sLineGuide);
        }
        showTableStyle();
    }
    else
    {
        // Do nothing
    }
}  

function getXmlCMConnectionUpstream(xmlResponse,pNode,sField,sValue,sNewId) {
    var upstreamChannels = $(xmlResponse).find(pNode);
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var qtyUpstreamCh = upstreamChannels.length;
    var UPSTREAM_PROPERTIES = 6;
    var htmlIndexWrite = 0;
    var isFirstIteraction = true;
    var CustID = $(xmlResponse).find('cid').text();//Richard_Chen@2011/12/08 for kdg
    // Remove the old table (keep the header)
    $(sField + ' tr:gt(1)').remove();
    
    if (iQtyNodes > 0)
    {
        // Update the field select
        for (var i=0;i<iQtyNodes;i++) 
        {
             var frequencies = $(upstreamChannels[i]).find('frequency');
             var power_levels = $(upstreamChannels[i]).find('power_level');
             var qtyModulations = $(upstreamChannels[i]).find('modulation').length;
             var symbol_rates = $(upstreamChannels[i]).find('symbol_rate');
             var channel_ids = $(upstreamChannels[i]).find('channel_id');
			 var frequency = (parseInt($(frequencies[0]).text(),10)/1000000);

             var sContentModulation = "";
             if (qtyModulations == 0)
             {
                 sContentModulation = getPromptTableValue(ERROR_XML_DATATYPE);
             }
             else
             {
                 var sLineBroken = '<br />';
                    
                 var modulations = $(upstreamChannels[i]).find('modulation').each(function(){
                     var modulation = $(this).find('*');
                     var sSecondElement = $(modulation[1]).text() + sLineBroken;
                     sContentModulation += sSecondElement;
                 });
             }


            var sLineGuide = '<tr>';

            sLineGuide += '<td class="td-value"><span>' + (i+1) + '</span></td>';
            sLineGuide += '<td class="td-value"><span>' + frequency + '</span></td>';
            sLineGuide += '<td class="td-value"><span>' + (parseInt($(power_levels[0]).text(),10)+60) + '</span></td>';
            sLineGuide += '<td class="td-value"><span>' + sContentModulation  + '</span></td>';
            sLineGuide += '<td class="td-value"><span>' + $(symbol_rates[0]).text() + '</span></td>';
            sLineGuide += '<td class="td-value"><span>' + $(channel_ids[0]).text()    + '</span></td>';
            sLineGuide += '</tr>';
            $(sField).append(sLineGuide);
        }
        showTableStyle();
    }
    else
    {
        // Do nothing
    }
} 
// Get Cable Modem Configuration Info from XML
// XML Example
// <docsis_config>
//      <user_access>readonly</user_access>
//      <frequency_plan>north_american</frequency_plan>
//      <upstream_channel_id>1</upstream_channel_id>
//      <favorite_frequency>447000000</favorite_frequency>
//      <dhcp_server_enabled>true</dhcp_server_enabled> 
// </docsis_config>

function getCofingInfo(xhr,pNode,field,value,sNewId) {

    var xmlResponse = $(xhr).find('docsis_config');
    var accessType = $(xmlResponse).find('user_access').text();
    var frequencyPlan = $(xmlResponse).find('frequency_plan').text();
    var channelId = $(xmlResponse).find('upstream_channel_id').text();
    var favoriteFrequency = $(xmlResponse).find('favorite_frequency').text();
    var favoriteFrequency2 = $(xmlResponse).find('favorite_frequency2').text();
    var favoriteFrequency3 = $(xmlResponse).find('favorite_frequency3').text();
    var hybridmode = $(xmlResponse).find('hybrid_mode').text();
    var dhcpEnabled = $(xmlResponse).find('dhcp_server_enabled').text();
    
    if(_CustomerId=="kdg")
    {
    favoriteFrequency = parseInt(favoriteFrequency,10) / 1000000;
    favoriteFrequency2 = parseInt(favoriteFrequency2,10) / 1000000;
    favoriteFrequency3 = parseInt(favoriteFrequency3,10) / 1000000;
    }
    
    if(favoriteFrequency=="0")
      favoriteFrequency = "";
    if(favoriteFrequency2=="0")
      favoriteFrequency2 = "";
    if(favoriteFrequency3=="0")
      favoriteFrequency3 = "";
    
    // Get the readonly status on prompt table.
    var readOnlyStatus = getPromptTableValue('readonly');
    
    // Default values to frequency plan
    var valueRelFrequencyPlan = 0;
    var valueIdFrequency = "none";
    
    // Value rel frequency plan map. Ex.: dual_hybrid = 4
    if (mapFrequencyPlan[frequencyPlan])
    {
        //valueRelFrequencyPlan = mapFrequencyPlan[frequencyPlan].rel;
        valueRelFrequencyPlan = mapFrequencyPlan[frequencyPlan].value;
        // Value Id frequency plan map. Ex.: japanese = idJapanStardard
        valueIdFrequency = mapFrequencyPlan[frequencyPlan].idFrequency;
    }
    
    // Get the frequency plan name translated
    var content = getPromptTableValue(valueIdFrequency);
    
    // If readonly status or frequencyPlan is invalid (none)
    if ( accessType == readOnlyStatus || valueRelFrequencyPlan == 0)
    {
		// Layout Adjustments
        $('#idFrequencyPlan,#idUpstreamChannelId,#idFavoriteFrequency').css('padding-right','10px');
		$('.cm-configuration label').css('width','150px');
        
        // Set the default select value using the xml frequencyPlan content 
        $("#div-frequency-plan")
            .addClass('div-modem-configuration-inputs')
            .html(content);
        $("#div-channelid")
            .addClass('div-modem-configuration-inputs')
            .html(channelId);
        $('#div-favorite-frequency')
            .addClass('div-modem-configuration-inputs')
            .html(favoriteFrequency);
        
        var enableDhcp = 'Disabled';
        if(dhcpEnabled == 'true') {
            enableDhcp = 'Enabled';
        }
        
        var labelContent = $('#idEnableDhcpServer').text();
        var labelTag = '<label for="enable-dhcp" class="left relative dynamic" ' +
                       'id="idEnableDhcpServer">' + 
                       labelContent + 
                       '</label>';
                       
        labelTag += '<div id="enable-disable">' + enableDhcp + '</div>';
        $('#div-checkbox').addClass('div-modem-configuration-inputs').html(labelTag);
        
        // Layout Adjustment
        $('#div-checkbox').css('margin-top','-4px');
        
        // Remove the submit buttom 
        $('input[name="save"]').remove();
    }
    else
    // Fill the input form
    {
        // Set the default select value attribute 'rel'
        //$('.frequecy-plan').attr('rel', valueRelFrequencyPlan);
        // Set the default select content
        //$('.frequecy-plan').html(content);
       
        $('#frequency-plan').attr({
            selectedIndex: valueRelFrequencyPlan-1
        });
        
        $('#channelid').attr({
            value: channelId
        });

        $('#favorite-frequency').attr({
            value: favoriteFrequency
        });
        
        $('#favorite-frequency2').attr({
            value: favoriteFrequency2
        });
        
        $('#favorite-frequency3').attr({
            value: favoriteFrequency3
        });
        
        if(hybridmode=="0")
        	$('#hybrid-mode-disabled').attr('checked', true);
        else
        	$('#hybrid-mode-enabled').attr('checked', true);
        
        // Change the dhcp enable checkbox 
        $('#form-config :checkbox').attr('disabled', false);
        if(dhcpEnabled == 'true') {
            $('#form-config :checkbox').attr('checked',true);
        }
        if(dhcpEnabled == 'false') {
            $('#form-config :checkbox').attr('checked',false);
        }
    }
    // Show the form after the content settings...
    $('#cm-configuration-content').show();
};

// Parse and Print XML - get the Telephone Registration List from file MtaStatus.xml used 
// on telephone_status.html
function getTelephoneRegistrationList(xmlResponse,pNode,sField,sValue,sNewId) {
    

	var sTelephoneRegistration = getPromptTableValue('telephone_registration_list');    
    var sTelephoneUserInfo = getPromptTableValue('message_port');
    var sTelephoneUserInfo2 = getPromptTableValue('telephone_impu_information');
	var sTelephoneStatus = getPromptTableValue('message_status');

    var sFirstField = sField + " td strong";
    var sSecondField = sField + " .td-value";

    $(sField).find('tr').remove('*');
    var node = $(xmlResponse).find(pNode).find('*');
    var iQtyNodes = $(xmlResponse).find(pNode).length; 

    var sLineGuide = '<tr>';
    sLineGuide += '<td><strong class="hidden dynamic" id="idLoading"></strong></td>';
    sLineGuide += '<td class="td-value"><span></span></td>';
    sLineGuide += '</tr>';

    for (var i=0;i<iQtyNodes;i++) {
        $(sField).append(sLineGuide);
    }
	
    var iHtmlCount = 0;	
	
    for(var i=0;i<node.length;i++) {		
		if(i < 4)
		{
			var sTelephoneRegistrationLine ="";
			if(_CustomerId == "kdg")
			{
				sTelephoneRegistrationLine = sTelephoneUserInfo + ' ' + $(node[i]).text()+' '+sTelephoneStatus;	
			}
			else
			{
				sTelephoneRegistrationLine = sTelephoneRegistration + ' ' + $(node[i]).text();
			}
       
        
			$(sFirstField).eq(iHtmlCount).html( sTelephoneRegistrationLine ).
				css('visibility','visible');
            
			var sContentTag = $(node[++i]).text();		
			$(sSecondField).eq(iHtmlCount).html( sContentTag );
			iHtmlCount++;	
		}
		else
		{		
			var pointCount = $(node[i]).text();
		
			var sTelephoneRUserInfoLine = sTelephoneUserInfo + ' ' + $(node[++i]).text()+' '+sTelephoneUserInfo2;
			$(sFirstField).eq(iHtmlCount).html( sTelephoneRUserInfoLine ).
				css('visibility','visible');
		
			var sContentTag2 ="";
			for(var j=0;j<pointCount;j++)
			{				
				if(j==0){
					sContentTag2 +='<b>';
					sContentTag2 += $(node[++i]).text();
					sContentTag2 +='</b>';
				}
				else if(j==pointCount-1){
					sContentTag2 += $(node[++i]).text();
				}
				else{
					sContentTag2 += ', '+$(node[++i]).text()+', ';
				}
			}		
	
			$(sSecondField).eq(iHtmlCount).html( sContentTag2 );	
			iHtmlCount++;
		}		
    }
    showTableStyle();	
}

/**
* Function for inserting log entries in a table related to
* Telephone signaling.
*
* @param xmlResponse - document 
* @param pNode       - node entry from list of log messages
* @param sField      - table id
* @param sValue      - table id + value 
* @param sNewId      - current language
*
* NOTE: Layout Example
*
*   Message [direction_content] [timestamp_value]
*   [message_content_1]
*   ...
*   [message_content_n]
*
*   Message [direction_content] [timestamp_value]
*   [message_content_1]
*   ...
*   [message_content_n]
* 
*/
function getXmlTelephoneSignalingLog(xmlResponse,pNode,sField,sValue,sNewId) {
    $(sField).find("tr").remove('*');
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var iHtmlWriteCount = 0;
    var sLineBroken = '<br />';

    var sHeadGuide = '<tr>';
    sHeadGuide += '<td><strong class="hidden dynamic" id="idLoading"></strong></td>';
    sHeadGuide += '</tr>';

    var sLineGuide = '<tr>';
    sLineGuide += '<td class="td-value"><span></span></td>';
    sLineGuide += '</tr>';
    
    for (var i=0;i<iQtyNodes;i++) {
        $(sField).append(sHeadGuide);
        $(sField).append(sLineGuide);
        var childrenNodes = $(xmlResponse).find(pNode)[i].childNodes;
        var sContentTag = '';
        var sMessage = '';

        for(var j=0;j<childrenNodes.length;j++) {
            if (childrenNodes[j].tagName != null){
                if (childrenNodes[j].tagName == "message") {
                    var nodeMessage = childrenNodes[j].childNodes;
                    for (var k=0; k<nodeMessage.length; k++) {
                        if (nodeMessage[k].tagName != null){
                            
                            // The value of node is alerady escaped. From this point on the value sent
                            // in the xml is equal to "<" instead of "&lt;". We need to recover the 
                            // escaped code for angle bracket performing the replace command below.
                            
                            var contentReplaced = nodeMessage[k].firstChild.nodeValue.replace(/</g,'&lt;');
                            
                            sMessage += contentReplaced + sLineBroken + sLineBroken;
                        }
                        else{
                            // Do nothing
                        }
                        
                    }
                }
                else {
                    sContentTag += $(childrenNodes[j]).text() + ' ';
                }
            }
            else{
                // Do nothing
            }
        }
        
        $(sField + " td strong")
            .eq(iHtmlWriteCount)
            .html(getPromptTableValue('idMessage') + ' ' + sContentTag)
            .css('visibility','visible');
        $(sValue)
            .eq(iHtmlWriteCount)
            .html( sMessage );
        
        iHtmlWriteCount++;
    }
    showTableStyle();
}

// MOTO_S - cqvds00022992 - Khalandar
function getSignalingProtocol()
{
    return "N/A";
}
// MOTO_E - cqvds00022992
// Parse and Print XML Info for Telephone -> Provisioning - > Call Features
function getXmlCallFeaturesLine(xmlResponse,pNode,sField,sValue,sNewId) {	

    var sProtocol = getSignalingProtocol();// MOTO - cqvds00022992 - Khalandar
	var PacketCable = $(xmlResponse).find('packet_cable').text();

    // MOTO_S - cqvds00022992 - Khalanda - If protocol is not SIP display the NCS specific message
    if(sProtocol != 'SIP')
    {
		if(sProtocol == 'NCS')
        	xmlContentError('#div-call-features', 'idNcsSpecific');
		else
			xmlContentError('#div-call-features', 'status_na');
        return;
    }
    // MOTO_E - cqvds00022992

	if(PacketCable == '2.0')
	{
		sField = '#t-tel-prov-call-features-packetcable20';
		sValue = sField + ' .td-value span';
		$('#t-tel-prov-call-features-packetcable20').show();
	}
	else
	{		
		sField = '#t-tel-prov-call-features';
		sValue = sField + ' .td-value span';
		$('#t-tel-prov-call-features').show();
	}
    var lines = $(xmlResponse).find('line_number');

    if ( !(lines.length == 2 || lines.length == 4) )
    {
        xmlContentError('#div-call-features', 'idErrorQtyLines');
        return;
    }
    
	if (_qtyLines == 0) {
        var HTML_LINE = getPromptTableValue('idLine');
        
		_qtyLines = lines.length;
        
        var cookieLineNumber = readCookie('lineNumber');
		
		for (i = 0; i < _qtyLines; i++) {
  /*          var lineNumber = $(lines[i]).text();
			$('<li><a href="#" rel="' +  i + '" class="block" id="idLine' + (i + 1)
			+ '">' + HTML_LINE + ' ' + lineNumber + ' </a></li>').appendTo('#div-call-features ul');*/
            var lineNumber = $(lines[i]).text();
			$('#CallFeatureLine option[value='+lineNumber+']').remove();	
			$('<option value="' + (i+1) + '" class="block" id="idLine' + (i + 1)
			+ '">' + HTML_LINE + ' ' + lineNumber + ' </option>').appendTo('#div-call-features select');
		}
		
		if (cookieLineNumber == 1 || cookieLineNumber == 2) {
			//$('.mta-line').text(HTML_LINE + ' ' + $(lines[cookieLineNumber]).text());
			$('#CallFeatureLine option[value='+cookieLineNumber+']').attr("selected", true);	
		} 
		else {
			//$('.mta-line').text( HTML_LINE + ' ' + $(lines[0]).text() );
			$('#CallFeatureLine option[value='+1+']').attr("selected", true);
			createCookie(1,lineNumber,1);
		}
		
		//selectPhoneLine();
	}

    $(sField).find("tr:gt(0)").remove('*');
    var node = $(xmlResponse).find(pNode).find('*');
    var iQtyNodes = $(xmlResponse).find(pNode).length; 
    var iQtyLines = $(sField).find("tr:gt(0)").length;
    
    if (iQtyNodes > 0)
    {
        var iNumParameters = node.length / iQtyNodes;
        
        var sLineGuide = '<tr>';
        for (var i=0;i<iNumParameters;i++) {
            sLineGuide += '<td class="td-value"><span></span></td>';
        }
        sLineGuide += '</tr>';

        for (var i=0;i<iQtyNodes-iQtyLines;i++) {
            $(sField).append(sLineGuide);
        }
        for(var i=0;i<node.length;i++) {
            var sContentTag = $(node[i]).text();
            $(sValue).eq(i).html( sContentTag );
        }
        
        showTableStyle();
        //selectPhoneLineCombo();
	}
    
}

// Parser Bootfile info
function getBootfileInfo(xmlResponse,pNode,field,value,newId) {
	var mainNode = $(xmlResponse).find(pNode);
    // Get the name of the Bootfile
	var fileName = $(mainNode).find('config_file_name').text();
	
	$('.title-cm-bootfile span').html(fileName);
	
	$(mainNode).find(field).find('content').each(
    function(){
    	$('<span class="block" />').html( $(this).text() ).appendTo('.cm-bootfile');
    });
};

// =================================================================================================
// 
// GENERIC FUNCTIONS
// 
// =================================================================================================
// This function create a string to be passed as the firts parameter in ajaxReq() inside Help pages
function helpXmlUrl(filePrefix) {
    // Get idiom ID
    var currentLang = getCurrentLanguage();       
    // Build the url string using the file name and the id language. Ex.: battery_en.xml
    xmlPath = filePrefix + '_' + currentLang + '.xml';
    
    return xmlPath;
};

// =================================================================================================
//
// GENERIC FUNCTIONS
//
// =================================================================================================

function readLanguages(xmlResponse)
{
    var nodes = $(xmlResponse).find('IDIOMS > *');
    var countLangLoaded = 0;
    var indexTobeLoaded = 0;
    var nodeId = "";
    var imgSrc = "";
    var jsSrc = "";
    var langName = "";
    var DefCusName = "";
	var IndexString = "";	/* CBN - 20140414 - Gary - return string in the multiple language id tag. */
	
	IndexString =  $(nodes).eq((nodes.length - 2)).attr('id');
    for(i=0;i<(nodes.length - 2);i++) {
        nodeId = $(nodes).eq(i).attr('id');
        imgSrc = $(nodes).find('IMG_SRC').eq(i).text();
        jsSrc = $(nodes).find('JS_SRC').eq(i).text();
        langName = $(nodes).find('NAME').eq(i).text();
        // (switch-lang.js) Print idiom flags on the top page
	/* CBN_S - 20140414 - Gary - return string in the multiple language id tag. */
        if (importLangScript(nodeId, jsSrc, langName))
        {
            putFlag(nodeId, imgSrc, langName);
            countLangLoaded++;
            //indexTobeLoaded = i;
        }
		
		if(IndexString.match(nodeId))
			indexTobeLoaded = i;
    }
    //indexTobeLoaded =  $(nodes).eq((nodes.length - 2)).attr('id');
	/* CBN_E - 20140414 - Gary - return string in the multiple language id tag. */
	/* CBN_S - 20141225 - Gary - Do not create 'customerName' cookie, use '_CustomerId' */
    //DefCusName = $(nodes).eq((nodes.length - 1)).attr('id');
    //var _customerName = readCookie('customerName');
    //if(_customerName!=DefCusName)
    //	eraseCookie('customerName');
    //createCookie('customerName',DefCusName,365);
	/* CBN_E - 20141225 - Gary - Do not create 'customerName' cookie, use '_CustomerId' */
    // in case of only one lang was sent by server
    //if (countLangLoaded == 1)
    //{
        nodeId = $(nodes).eq(indexTobeLoaded).attr('id');
        imgSrc = $(nodes).find('IMG_SRC').eq(indexTobeLoaded).text();
        jsSrc = $(nodes).find('JS_SRC').eq(indexTobeLoaded).text();
        langName = $(nodes).find('NAME').eq(indexTobeLoaded).text();
        
        var valueCookie = imgSrc+'*'+langName+'*'+nodeId;
        setLanguage(imgSrc+'*'+jsSrc+'*'+nodeId);
        // set new value in the cookie
        createCookie('prefIdiom',valueCookie,365);
    //}
    
    return countLangLoaded;
}

function cookieIdiom()
{
    // Read Cookie For Language
    var cookieIdiom = readCookie('prefIdiom');

    if (cookieIdiom != null) {

        // (switch-lang.js) Set the current idiom and save on cookie
        setLanguage(cookieIdiom);
    } else {

        // (switch-lang.js) Set the default idiom and save on cookie
        // Example string content on cookie - images/pt.gif*Potuguese*pt
        var sSrcAttr = $('#switch img').attr('src');
        var sAltAttr = $('#switch img').attr('alt');
        var sIdAttr = $('#switch img').attr('id');
        
        // (switch-lang.js) Set the current idiom and save on cookie
        setLanguage(sSrcAttr + COOKIE_SEPARATOR + sAltAttr + COOKIE_SEPARATOR + sIdAttr);
    }

}


// Verify if there is a valid user cookie and show the advanced itens
function advancedUserContent() {
    // If the user is a operator
    if(_userCookie != 'none') {
    
        // Put the 'Welcome' greeting to the user
    	$('#welcome').html('<span class="dynamic" id="idWelcome" />' + ' ' + _userCookie);
        // Remove the link 'Operator Access'
    	$('.operator-access').remove();
        // Put the link 'Logout' in the place of 'Operator Access'
    	$('<a class="logout block absolute dynamic" id="idLogout" />')
        .appendTo('#div-operator-access');
		
		// Put "QoS - Quality Of Service" tab in the telephone_call.html page
		$('.tab-call-qos').show();
		
        //Put "Logs" title in Telephone Logs page when the user is a operator
		if(_userCookie == "root")
        	$('<h3 class="tabs-page-title dynamic" id="idLogs"></h3>').appendTo('#div-title-tel-logs'); //CBN - Ken - 20101214 - only for root user

    }
}

//The session is timeout/remove. Change menu bar to logout status
function logoutUserContent() {
    // Remove the 'Welcome' greeting to the user
	$('#welcome').remove();
    // Remove the link 'Operator Access'
	$('.operator-access').remove();
    // Put the link 'Logout' in the place of 'Operator Access'
	$('<a href="login.html" class="operator-access block absolute dynamic" id="idOperatorAccess" >' + getPromptTableValue("idOperatorAccess") + '</a>')
    .appendTo('#div-operator-access');
}

function accessUser() {
    // Logout operation
    $('.logout').click(function() {
    
        var sUrlServer = urlLocation() + LOGOUT_SERVER_PATH;
        var blogout = false;
        
        try{
            $.ajax({url: sUrlServer,
                type: 'POST',
                dataType: "text",
                async:false,
                error:function()
                {
                    alert(getPromptTableValue("gw_common_errorstr_0016"));
                },
                success:function(responseData)
                {
                    blogout = true;
                }
          });
        }
        catch (e)
        {
           alert('EMTA - ' + e.message);
        }
        
        var pathName = window.location.pathname;
        if (blogout == true ) {
            // Erase the cookie called 'userData'
            eraseCookie('userData');
            
            // Redirect to root page
            window.location.href = urlLocation() + '/' + ROOT_PAGE;	// CBN - 20111007
        }
        else {
            window.location.href = pathName;
        }
        return blogout;
    });
}

$('a:not(#switch-language a)').mouseover(
function() {
    // If select idiom drop down is visible
	if( $('#choose-language').is(':visible') ) {
        // Hide it
		$('#choose-language').hide();
	}	
});

// Idiom combo select
function languageOperations() {
    // Set css background property 
    $('#switch').css('background','url(images/language.gif) no-repeat left');
    
    // On mouse over
    $('#switch,#choose-language').hover(
    function() {
        // Change the 'position' css property to 'static'
        $('#menu li').css('position','static');
        // Change css 'background' property 
        $('#switch').css('background','url(images/language_hover.gif) no-repeat left');
    
    // On mouse out
    }, function() {
        // Change the 'position' css property to 'static'
        $('#menu li').css('position','relative');
        // Change css 'background' property 
        $('#switch').css('background','url(images/language.gif) no-repeat left');
    
    });
    
    $('#switch,#choose-language').toggle(
    function() {
        // If select idiom drop down is visible
        if( $('#choose-language').is(':visible') ) {
            // Change the 'position' css property to 'relative'
            $('#menu li').css('position','relative');
            // Hide it
            $('#choose-language').hide();
        } else {
            // Change the 'position' css property to 'static'
            $('#menu li').css('position','static');
            // Show it
            $('#choose-language').show();
        }
    
    }, function() {
        // If select idiom drop down is visible
        if( $('#choose-language').is(':visible') ) {
            // Change the 'position' css property to 'relative'
            $('#menu li').css('position','relative');
            // Hide it
            $('#choose-language').hide();   
        } else {
            // Change the 'position' css property to 'static'
            $('#menu li').css('position','static');
            // Show it
            $('#choose-language').show();   
        }
            
    }); 
    
    $('#choose-language a img').click(
    function() { 
        // If select idiom drop down is visible                                       
        if( $('#choose-language').is(':visible') ) {
            // Hide it
            $('#choose-language').hide();
        } else {
            // Show it
            $('#choose-language').show();
        }
        
    });
	
	$('body > *').click(
    function() {
        // If select idiom drop down is visible                                       
		if( $('#choose-language').is(':visible') ) {
            // Hide it
			$('#choose-language').hide();
		}
		// If frequency plan drop down is visible
		if( $('#dpdw-freq-plan ul').is(':visible') ) {
            // Hide it
			$('#dpdw-freq-plan ul').hide();
		}
	});
	/* CBN20110415 wilson add start: special hacking for IE browser */
	/* CBN20140311 wilson modify start: it seems we do not need following special hacking.
	this also create an issue of language string is disappear when using Firefox to resize the page. */
	//$("#idSwitchLanguage").after('&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');	
	/* CBN20140311 wilson modify start: it seems we do not need following special hacking */
	/* CBN20110415 wilson add end: special hacking for IE browser */
}

// Tables Style | Alternating colors on each line
function showTableStyle() {
    $('table tr:odd').css('background','#FFF');
    $('table tr:even').css('background','#F5F5F5');
}

function selectTable() {
    $('table tr').hover(
    function() {
        // Set 'tr-hover' css class to selected element
        $(this).addClass('tr-hover');
    },function() {
        // Remove 'tr-hover' css class to selected element
        $(this).removeClass('tr-hover');
    });
}

function selectMenuFrequencyPlan() {
    // Put css 'background' property 
    $('.frequecy-plan').css('background','url(images/bg_frequency_plan.gif) no-repeat');
    
    $('.frequecy-plan,#dpdw-freq-plan ul').hover(function() {
        // Change css 'background' property 
        $('.frequecy-plan').css('background','url(images/frequency_plan_hover.gif) no-repeat');                            
    },function() {
        // Change css 'background' property 
        $('.frequecy-plan').css('background','url(images/bg_frequency_plan.gif) no-repeat');
    });
    
    $('.frequecy-plan').toggle(
    function() {
        // Show Frequency Plan drop down options
        $('#dpdw-freq-plan ul').show();
    },function()  {
        // If Frequency Plan drop down options is visible
        if( $('#dpdw-freq-plan ul').is(':visible') ) {
            // Hide it
            $('#dpdw-freq-plan ul').hide(); 
        } else {
            // Show it
            $('#dpdw-freq-plan ul').show(); 
        }
    });
    
    $('#dpdw-freq-plan ul li a').click(
    function() {
        // Get the content tag
        var newFreqPlanContent = $(this).text();   
        // Get the attrubute rel
        var newFreqPlanRel = $(this).attr('rel');   
        // Set the new content
        $('.frequecy-plan').html(newFreqPlanContent).css('background',
                                                  'url(images/bg_frequency_plan.gif) no-repeat');
        // Set the new attribute rel
        $('.frequecy-plan').attr('rel',newFreqPlanRel);
        
        // Hide Frequency Plan drop down options 
        $('#dpdw-freq-plan ul').hide();
        
        return false;
    });
}

function selectPhoneLine() {
    // Put css 'background' property 
    $('.mta-line').css('background','url(images/bg_frequency_plan.gif) no-repeat');
    
    $('.mta-line,#div-call-features ul').hover(function() {
        // Change css 'background' property 
        $('.mta-line').css('background','url(images/frequency_plan_hover.gif) no-repeat');                            
    },function() {
        // Change css 'background' property 
        $('.mta-line').css('background','url(images/bg_frequency_plan.gif) no-repeat');
    });
    
    $('.mta-line').toggle(function() {
        // If Phone Line drop down options is visible
		if( $('#div-call-features ul').is(':visible') ) {
            // Hide it
            $('#div-call-features ul').hide(); 
        } else {
            // Show it
            $('#div-call-features ul').show(); 
        }
    },function() {
        // If Phone Line drop down options is visible
        if( $('#div-call-features ul').is(':visible') ) {
            // Hide it
            $('#div-call-features ul').hide(); 
        } else {
            // Show it
            $('#div-call-features ul').show(); 
        }
    });
    
    $('#div-call-features ul li a').click(
	function() {
        // Hide it
        $('#div-call-features ul').hide();
        return false;
    });
}

function selectPhoneLineCombo()
{
        _qtyLines = 0;
        var lineNumber = $('#CallFeatureLine').val();
        
		var cookieLineNumber = readCookie('lineNumber');
        
        if(lineNumber!=cookieLineNumber)
		{
        loadTLProvisioningTable('#div-call-features','xml/ProvisioningCallFeatures.xml', 
									'line:eq(' + (lineNumber-1) + ') feature_entry', 
                                getXmlCallFeaturesLine);
			createCookie('lineNumber',lineNumber,1);
		}
}

// Tabs dynamic style
function tabsStyle(selectedTab) {
    // Change css 'background' and 'border-bottom' property 
	$(selectedTab).css('background','#FFF').css('border-bottom','1px solid #FFF');

    $('#tabs a').click(
    function() {
        // Change css 'background' and 'border-bottom' property 
        $('#tabs a:not(this)')
            .css('background','url(images/bg_tab.gif) repeat-x')
            .css('border-bottom','1px solid #E1E1E1');
        
        // Change css 'background' and 'border-bottom' property 
        $(this).css('background','#FFF').css('border-bottom','1px solid #FFF');
    });
};

// Tabs dynamic style
function firstTabsStyle(){
    $('#tabs a')
        .css('background','url(images/bg_tab.gif) repeat-x')
        .css('border-bottom','1px solid #E1E1E1');
    $('#tabs a')
        .eq(0)
        .css('background','#FFF')
        .css('border-bottom','1px solid #FFF');
};

// Show and Select a tab at time
function telephoneCallTabs() {
    showTableStyle();
	tabsStyle('.tab-call-status');

    $('.tab-call-status').click(
    function() {
        loadCallStatusTable();
        return false;
    });

    $('.tab-call-history').click(
    function() {
        var sHtmlLoad = '#t-tel-call-history';
        var sFile =  'xml/LineCallHistory.xml';
        pNode = 'call';
        loadCallQosHistoryTable(sHtmlLoad, sFile, pNode);
        return false;
    });

    $('.tab-call-qos').click(
    function() {
        var sHtmlLoad = '#t-tel-call-qos';
        var sFile =  'xml/Qos.xml';
        pNode = 'qos';
        loadEnumTagsFromFile('Qos');
        loadCallQosHistoryTable(sHtmlLoad, sFile, pNode);
        return false;
    });
}

// Show and Select a tab at time
function telephoneLogsTabs()
{
    showTableStyle();
    tabsStyle('.tab-telephone-log');

    $('.tab-telephone-log').click(
    function() {
        loadMTALogsTable();
        return false;
    });

    $('.tab-call-signaling-log').click(
    function() {
        loadMTASignalingLogsTable();
        return false;
    });
};

// Show and Select a tab at time
function telephoneProvisioningTabs() {
    showTableStyle();
    tabsStyle('.tab-provisioning-setup');

    $('.tab-provisioning-setup').click(
    function() {
		_qtyLines = 0;
        // Erase 'lineNumber' cookie
		eraseCookie('lineNumber');
		$('#div-call-features').hide();
        loadTLProvisioningTable('#t-tel-prov-setup',
                                'xml/PkDhcp.xml', 
                                'pk_dhcp', 
                                getXmlInfoWithList);
        loadEnumTagsFromFile('PkDhcp');
        return false;
    });

    $('.tab-provisioning-line').click(
    function() {
		_qtyLines = 0;
        // Erase 'lineNumber' cookie
		eraseCookie('lineNumber');
		$('#div-call-features').hide();
        loadTLProvisioningTable('#t-tel-prov-line-ncs-sip',
                                'xml/AdvLineProvisioning.xml', 
                                'pk_line_provisioning', 
                                getXmlLineProvisioning);
        loadEnumTagsFromFile('AdvLineProvisioning');
        return false;
    });
    
    $('.tab-provisioning-call-features').click(
    function() {	
		_qtyLines = 0;
        // Erase 'lineNumber' cookie
		eraseCookie('lineNumber');
		$('#div-call-features').show();
        loadTLProvisioningTable('#div-call-features',
                                'xml/ProvisioningCallFeatures.xml', 
                                'line:eq(0) feature_entry', 
                                getXmlCallFeaturesLine);
        return false;
    });

    $('.tab-provisioning-erros').click(
    function() {
		_qtyLines = 0;
        // Erase 'lineNumber' cookie
		eraseCookie('lineNumber');
		$('#div-call-features').hide();
        loadTLProvisioningTable('#t-tel-prov-error',
                                'xml/ProvisioningError.xml', 
                                'provisioning_error', 
                                getXmlList);
        return false;
    });

};

function tooltipDHCPModemConfiguration() {
    $('.ico-info').toggle(function() {
        $('#idInfoEnableDhcp').fadeIn(200);
    },function() {
        $('#idInfoEnableDhcp').fadeOut(200);
    });
}

// GET Operator Login
function sendGETUserLogin() {
    var errorMessageSelector = '#form-login p';
    var loginEmptyIdPrompt = 'idLoginEmpty';
    var loginServerNotAvailableIdPrompt = 'idLoginServerNotAvailable';
    var loginIncorrectIdPrompt = 'idLoginIncorrect';
    var loginIncorrectRightPrompt = 'idLoginRightIncorrect';

    $('.bt-submit').click(
    function() {

        // Select the password field
        var sLogin = $('#myusername').attr('value');
        var sPassword = $('#mypassword').attr('value');
        if ( sLogin == '' ) {
            $(errorMessageSelector)
                .attr('id',loginEmptyIdPrompt)
                .html(getPromptTableValue(loginEmptyIdPrompt))
                .fadeIn(DELAY_SHOW_MESSAGES);
            return false;
        }
        var sUrlServer = urlLocation() + LOGIN_SERVER_PATH;
        var parameters = {'token' : _Token, 'password': sPassword, 'user': sLogin };

        try{
            $.ajax({url: sUrlServer,
                type: 'POST',
                data: parameters,
                dataType: "text",
                error: function()
                {
                    $(errorMessageSelector)
                        .attr('id',loginServerNotAvailableIdPrompt)
                        .html(getPromptTableValue(loginServerNotAvailableIdPrompt))
                        .fadeIn(DELAY_SHOW_MESSAGES);
                        loadGlobalVar();
                },
                success: function(responseData)
                {
                   if (responseData == 'restrict') {
                        $(errorMessageSelector)
                            .attr('id',loginIncorrectRightPrompt)
                            .html(getPromptTableValue(loginIncorrectRightPrompt))
                            .fadeIn(DELAY_SHOW_MESSAGES);
                        return false;
                   }
                   
                  if (responseData == 'false') {
                        loadGlobalVar();
                        $(errorMessageSelector)
                            .attr('id',loginIncorrectIdPrompt)
                            .html(getPromptTableValue(loginIncorrectIdPrompt))
                            .fadeIn(DELAY_SHOW_MESSAGES);
                        return false;
                    }
                    sLogin = responseData;
                    // This cookie expire in 30 minutes
                    //createCookie("userData",sLogin,(1/48));
                    // Redirect to root page
                    location.href = ROOT_PAGE;
                    return true;
                }
          });
        }
        catch (e)
        {
           alert('EMTA - ' + e.message);
        }
        return false;

    });
}
// POST Modem Configuraion
function sendPOSTModemConfiguration() {
    
    $('.bt-save').click(function() {
        var fqPlanItem = $('.frequecy-plan').attr('rel');
        var channelIdContent = $('#channelid').attr('value');
        var favoriteContent = $('#favorite-frequency').attr('value');
        var isDHCPChecked = $('#form-config :checkbox').attr('checked');

        var sUrlServer = urlLocation() + '/modem_configuration.html';
        var parameters = {'frequencyPlan': fqPlanItem , 
                          'channelId': channelIdContent, 
                          'favoriteFrequency' : favoriteContent, 
                          'dhcpEnable' : isDHCPChecked};

        try {
           $.ajax({url: sUrlServer,
                type: 'POST',
                data: parameters,
                error: function(){
                    showErrorMessage('#form-config');
                }
           });
        }
        catch (e)
        {
           alert('EMTA - ' + e.message);
        }
        return true;
    });
}

// Cable Modem boot file 
function cmBootfile() {
    // Reading 'userData' cookie
	//var userCookie = readCookie('userData');
	if (_userCookie != "none") {
				
		$('#div-bootfile').load('cm_bootfile.html',
        function() {
			multiAjaxReq('xml/DocsisConfigFile.xml',
                         'docsis_config_file',
                         'config_content_list',
                         '',
                         getBootfileInfo,-1)											 
		});
	} else {
		// Do nothing
	}
};

// =================================================================================================
// 
// UTILS
// 
// =================================================================================================

/// <summary>
/// Verify if is a invalid tag. 
/// </summary>
///
/// <param name="tag">Object XML</param>
/// <return>true/false</return>
function isValidTag(tag)
{
    return !(tag.tagName == null || tag.childNodes.length > 1);
}

// Generate a URL string like: protocol//domain/filePath -> http://localhost/siteName
// CBN_S - 20111007
function urlLocation() {
    var sPath = window.location.pathname;
    var sHost = window.location.host;
    var sHostName = window.location.hostname;
    var sPort = window.location.port;
    if( (sHostName.search(":")>=0) && (sHost.search("\\[")<0))
    {
    	sHost = "["+sHostName+"]";
    	if( sPort != "80")
    		sHost += ":"+sPort;
    }
    var iIndexPosition = sPath.lastIndexOf('/');
    var sUrlServer = window.location.protocol + '//' + sHost + 
                     sPath.substr(0,iIndexPosition);
    return sUrlServer;
}
// CBN_E - 20111007

// Show a message error on top page. Hide or opacity the content of the page.
function showErrorMessage(tableId)
{
	var error_display_html = 
		'<p class="error-title dynamic" id="idError">'+getPromptTableValue("idError")+'</p> \
		 <p class="left"> \
		 	<span class="dynamic" id="idErrorDesc">'+getPromptTableValue("idErrorDesc")+'</span>&nbsp; \
			<a href="#" class="dynamic" id="idTryAgain">'+getPromptTableValue("idTryAgain")+'</a>\
		 </p> \
		 <br />';
    // Clear the id table
    var tableIdParts = tableId.trim().split(' ');
    if (tableIdParts.length > 1) 
    {
        tableId = tableIdParts[0];
    }

    if (!_arrayXmlGettingError.contains(tableId))
    {
        // Adding xml file name at the global array
        _arrayXmlGettingError.push(tableId);
    }
    
    // Show the error message
    $('#error-display').empty();
    $('#error-display').html(error_display_html);
    $('#error-display').fadeIn(DELAY_SHOW_MESSAGES); 
    $('#tabs a').css('border-top','1px solid #E1E1E1');
			
    // Default variable used to check if there is some XML content inside the tables
	var contentTable = $(tableId + ' tr td span').text();
    // Default variable used to check if there is some XML content inside de tabs
    var contentTab = $('#box-call-info table tr td span, .div-content-ajax-tables table tr td span')
    .text();
    
    if (contentTable != '' || contentTab != '') { 
        // Opacity if there is XML content that can be read for the subscriber or operator
		$(tableId)
        .animate({
            opacity: HALF_OPACITY						
        });
    } else {
        // Hide table if there is not XML content
		$(tableId)
        .fadeOut(DELAY_SHOW_MESSAGES / 2);
    }
}

// Hide the message error on top page. Show or opacity back the content of the page.
function hideErrorMessage(tableId)
{
	//if(tableId=="")		/* CBN - 20110824 */
		//return;
    // Clear the id table
    var tableIdParts = tableId.trim().split(' ');
    if (tableIdParts.length > 1) 
    {
        tableId = tableIdParts[0];
    }

    // Remove the error entry of the list
    _arrayXmlGettingError.removeByElement(tableId);
    
    // If the list of errors is empty
    if (_arrayXmlGettingError.length == 0) 
	{
	   // Hide the error message
       $('#error-display').fadeOut(DELAY_SHOW_MESSAGES);
       $('#error-display').empty();
	}

    // Default variable used to check if there is some XML content inside the tables
    var contentTable = $(tableId + ' tr td span').text();
    // Default variable used to check if there is some XML content inside de tabs
    var contentTab = $('#box-call-info table tr td span, .div-content-ajax-tables table tr td span')
    .text();
    
    if(contentTable != '' || contentTab != '') { 
        // Opacity back if there is XML content that can be read for the subscriber or operator
		$(tableId)
		.animate({
            opacity: FULL_OPACITY						
        });
    } else {
        // Show table if there is not XML content
		$(tableId)
        .fadeIn(DELAY_SHOW_MESSAGES / 2);
    }
}

// Verify if there is 2 or 4 lines and show the lines numbers on table's headers. 
function setNumberOfLines(iQtyNodes, lineNumbers, sHtmlId)
{
    var sNewId = getCurrentLanguage();
    var htmlLine = getPromptTableValue('idLine');
    var result = true;
    
    // Show the hidden colums of the table
    if (iQtyNodes == 2 && lineNumbers.length == 2)
    {
        $(sHtmlId).find('#idLine1').html(htmlLine + ' ' + $(lineNumbers[0]).text());
        $(sHtmlId).find('#idLine2').html(htmlLine + ' ' + $(lineNumbers[1]).text());
    }
    else if (iQtyNodes == 4 && lineNumbers.length == 4) {
        
        $(sHtmlId).find('.none').show();
        $(sHtmlId).find('#idLine1').html(htmlLine + ' ' + $(lineNumbers[0]).text());
        $(sHtmlId).find('#idLine2').html(htmlLine + ' ' + $(lineNumbers[1]).text());
        $(sHtmlId).find('#idLine3').html(htmlLine + ' ' + $(lineNumbers[2]).text());
        $(sHtmlId).find('#idLine4').html(htmlLine + ' ' + $(lineNumbers[3]).text());
    }
    else
    {
        xmlContentError(sHtmlId, 'idErrorQtyLines');
        result = false;
    }
    return result;
}

// Clear the table and show message like: "Number of lines wrong"
function xmlContentError(idToRemove, idMessagePrompt)
{
    var sNewId = getCurrentLanguage();
    var arrayIdRemove = idToRemove.trim().split(' ');
    var errorMessage = '';
    
    if (arrayIdRemove.length > 1)
    {
        idToRemove = arrayIdRemove[0];   
    }
    
    // If the tag is a table, write a header line on the table 
    if ($(idToRemove)[0].tagName.toLowerCase() == 'table')
    {
        errorMessage = '<thead><tr>' + 
                       getPromptTableValue(idMessagePrompt) + 
                       '</tr></thead>';
    }
    // If it's another tag type, write a single span
    else
    {
        errorMessage = '<span>' + 
                       getPromptTableValue(idMessagePrompt) + 
                       '</span>';
    }
                       
    $(idToRemove)
        .addClass('xml-content-error')
        .html(errorMessage);
    clearInterval(_intervalCallAjax);
    return false;
}

// Checks if the number of information (by log entry) is correct. This calculation is done 
// using the first log entry.
function checkFormationLog(xmlResponse, pNode, sField)
{
    var resultCheck = false;
    
    var iQtyCells = $(xmlResponse).find(pNode).find('*').length;
    var iQtyEntries = $(xmlResponse).find(pNode).length;
    if (iQtyEntries > 0)
    {
        // Get the number of informations in the first entry
        var firstEntry = $(xmlResponse).find(pNode)[0];
        var iQtyInformationByEntry = $(firstEntry).find('*').length;
        if ( (iQtyInformationByEntry * iQtyEntries) == iQtyCells )
        {
            resultCheck = true;
        }
    }
    
    if (!resultCheck)
    {
        xmlContentError(sField, 'idLogBadFormed');
    }
    return resultCheck;
}

// UNUSED 
// Clear the html elements that the element SPAN inside of a TD tag. The line is completely removed.
//  <tr>
//     <td><strong class="hidden dynamic" id="idLoading"></strong></td>
//     <td class="td-value"><span></span></td>
//  </tr>
function clearEmptyLines()
{
    var cells = $('td span').find('*');
    
    $('td span').each(
    function()
    {
        if ($(this).text().trim() == '')
        {
            // Get the element tr and remove it
            $(this).parent().parent().remove();
        }
    });
}

// Redirect function - update the counter and redirect to the url parameter when the 'seconds' is 0.
function counterRedirect(seconds,url, idHtmlToPrint){
    counterRedirect1 = setTimeout('redirect(\''+url+'\')', seconds*1000);
    updateScreen(seconds, idHtmlToPrint);
}
// PRIVATE
// Print the seconds on the page using the specific html id
function updateScreen(seconds, idHtmlToPrint){
    if (seconds > 0) {
            $(idHtmlToPrint).html(seconds);
            seconds = seconds-1;
            counterRedirect2 = setTimeout(
                                    function(){updateScreen(seconds,idHtmlToPrint)}, 
                                    1000);
    }
}
// PRIVATE
function redirect(url)
{
    window.location = url;
}

function hasOperatorAccess()
{
    return  (_deviceConfig && !_deviceConfig.operatorAccess ? false : true);
}

// =================================================================================================
// 
// Type Validation and data convertions
// 
// =================================================================================================

/// <summary>
/// Function for identifying if one value is a duration type
/// </summary>
///
/// <param name="tagValue">string with value of tag</param>
/// <returns name="result">Returns 'true' if the value is a duration, otherwise 'false'.</returns>

function isDurationType(tagValue)
{
    // "P30DT10H20M0S"
    var regExp1st = /^P[0-9]{1,3}DT([0-1]?[0-9]|2[0-3])H[0-5]?\dM[0-5]?\dS$/;
    
    // "PT10H20M5S"
    var regExp2nd = /^PT([0-1]?\d|2[0-3])H[0-5]?\dM[0-5]?\dS$/;

    // "PT20M5S"
    var regExp3rd = /^PT[0-5]?\dM[0-5]?\dS$/;

    var result = false; // The value (by default) is not a duration type
    // test tag value with 1st option
    
    result = (tagValue.match(regExp1st) != null ||
              tagValue.match(regExp2nd) != null ||
              tagValue.match(regExp3rd) != null);
    return result;
}


/// <summary>
/// Function for loading enumerations values related to file
/// </summary>
///
/// <param name="sFileName">file name</param>
/// <returns name="">Returns 'true' if the enum was loaded, otherwise 'false'</returns>

function loadEnumTagsFromFile(sFileName, isConcat)
{
    if (isConcat == null || isConcat == false)
    {
        _arrayEnumTranslate = this.enumTag[sFileName] ;
    }
    else
    {
        _arrayEnumTranslate.concat(this.enumTag[sFileName]);
    }
    return (_arrayEnumTranslate == null ? false : true);
}

/// <summary>
/// Function for identifying is the tag has a enum type
/// </summary>
///
/// <param name="tagValue">string with value of tag</param>
/// <returns name="result">Returns 'true' if the value is a duration, otherwise 'false'</returns>

function isEnumTagValue(sEnumTagValue)
{
    var result = false;
    var enumIndex = 0;

    if (_arrayEnumTranslate != null)
    {
        while (enumIndex < _arrayEnumTranslate.length && result == false)
        {
            result = _arrayEnumTranslate[enumIndex] == sEnumTagValue ? true : false;
            enumIndex++;
        }
    }
    return result;
}

/// <summary>
/// Function for converting DateTime to String. 
/// Input: 2008-05-30T09:00:07 Output: 2008-05-30 09:00:07
/// </summary>
///
/// <param name="tagValue">string with value of tag</param>
/// <returns name="strDateTime">Returns string datetime</returns>

function convertDateTimeToString(tagValue)
{
    var DATE_TIME_SEPARATOR = 'T';
    return tagValue.replace(DATE_TIME_SEPARATOR,' ');;
}

/// <summary>
/// Function for converting time code to full time
/// </summary>
///
/// <param name="tagValue">string with value of tag</param>
/// <returns name="strDuration">Returns full time</returns>

function convertToDuration(tagValue)
{
    var strDuration = '';
    var strDay    = getDurationValue (tagValue, 'P[0-9]{1,2}D');
    var strHour   = getDurationValue (tagValue, 'T[0-9]{1,2}H');
    var strMinute = getDurationValue (tagValue, 'H[0-9]{1,2}M');
    var strSecond = getDurationValue (tagValue, 'M[0-9]{1,2}S');

    // in case of duration to have only min and sec: "PT20M5S" > "20m:5s"
    if (strMinute == null) strMinute = getDurationValue (tagValue, 'T[0-9]{1,2}M');

    // string to be created: 20 days 10h:20m:0s
    strDuration = strDay    != null ? strDuration + strDay    + getPromptTableValue('message_duration_days')  : '';
    strDuration = strHour   != null ? strDuration + strHour   + 'h:'     : '';
    strDuration = strMinute != null ? strDuration + strMinute + 'm:'     : '';
    strDuration = strSecond != null ? strDuration + strSecond + 's'      : '';

    return strDuration;
}

/// PRIVATE
/// <summary>
/// Function for getting a specific value of duration string
/// Note: this value have to stay between two delimiter characters
/// </summary>
///
/// <param name="tagValue">string with value of tag</param>
/// <param name="regExt">part of regular expression</param>
/// <returns name="result">Returns the specific value of duration string, otherwise null</returns>

function getDurationValue(tagValue, regExp)
{
    var result       = null;
    var indexChar1st = -1;
    var indexChar2nd = -1;
    var char1st      = '';
    var char2nd      = '';
    var regExpLen    = regExp.length;
	var len          = 0;

    if (tagValue.search(regExp) != -1) {
        // getting delimiter character of regular expression
        char1st = regExp.charAt(0);
        char2nd = regExp.charAt(regExpLen-1);

        // getting index of characters of tag value
        indexChar1st = tagValue.search(char1st);
        indexChar2nd = tagValue.search(char2nd);

        // regular expression: P.DT
        // index values      : 0123
        // or
        // regular expression: P.DT
        // index values      : 012
        // len must be equal to 1 or 2
        len = indexChar2nd - indexChar1st - 1;

        // getting the value
        result = tagValue.substr(indexChar1st+1, len);
    }

    return result;
}

// CBN_S - 20140220 wilson add
function kdEngText(id, checkOnly)
{
	/* 
	format: { str: "this string need to be translate", id : "string_id"}
	*/
	var multiLangStrings = [
		{ str: "idwireless", id: "idkdwireless" },
		{ str: "idcrumbhomegatewaywirelessbasic", id: "idkdwlanbasic" },
		{ str: "idcrumbhomegatewaywirelessstatus", id: "idkdwlanstatus" },
		{ str: "idcrumbhomegatewaywirelesssecurity", id: "idkdwlansecurity" },
		{ str: "idcrumbhomegatewaywirelesswps", id: "idkdwlanwps" },
		{ str: "idcrumbhomegatewaywirelessaccesscontrol", id: "idkdwlanaccesscontrol" },
		{ str: "idcrumbhomegatewaywirelesstimecontrol", id: "idkdwlantimecontrol" },
		{ str: "idcrumbhomegatewaywirelessrepeater", id: "idkdwlanrepeater" },
		{ str: "idcrumbhomegatewaywirelesssitesurvey", id: "idkdwlansitesurvey" },
		{str: "idwirelessstatus",id :"idwirelessstatus2"}
	];
	
	for (var i = 0; i < multiLangStrings.length; i++) {
		if(id.toLowerCase() == multiLangStrings[i].str)
		{
			if(checkOnly == 1)
				return true;
			return multiLangStrings[i].id;
		}
	}
	return false;
}
// CBN_E - 20140220 wilson add

/// PRIVATE
/// <summary>
/// Function to search a specific value in the prompt-table (using the current idiom).
/// </summary>

/// <param name="sValue">string with content to be translated</param>
/// <returns name="result">translated content or default error value</returns>
function getPromptTableValue(sValue) 
{
    var self = this;
    var result = '';
    if (sValue != '')
    {
        // Get Current Idiom
        var sIdiom = getCurrentLanguage();
        try
        {
            // CBN_S - 20140220 wilson add
            if( (_CustomerId == "kdg") 
		&&(true == kdEngText(sValue, 1))
		&& ("en" == sIdiom) )
            {
		//special hacking for KD Web GUI
		sValue = kdEngText(sValue, 0);				
            }
            // CBN_E - 20140220 wilson add
			
            result = self[sIdiom][sValue.toLowerCase()];
            if (typeof(result) == UNDEFINED_TYPE)
            {
                result = self[sIdiom][ERROR_XML_TRANSLATE];
            }
        }
        catch (e)
        {
            result = self[sIdiom][ERROR_XML_TRANSLATE];
        }
    }
    return result;
}

/* CBN - 20130913 - Gary - add for setting language string. */
/// PRIVATE
/// <summary>
/// Function to search a specific value in the prompt-table (using the current idiom).
/// </summary>
/// <param name="sValue">string index with content to be replace</param>
/// <param name="newString">use the newString to replace the old</param>
function setPromptTableValue(sValue,newString) 
{
    var self = this;
    var oldString = '';
    
	if (sValue != '')
    {
        // Get Current Idiom
        var sIdiom = getCurrentLanguage();
		
		oldString = self[sIdiom][sValue.toLowerCase()];

		if ((typeof(oldString)!=UNDEFINED_TYPE)&&(typeof(newString)!=UNDEFINED_TYPE))
			self[sIdiom][sValue.toLowerCase()] = newString;
		else
            return false;
    }
	return true;
}



/// PRIVATE
/// <summary>
/// Type Validation function. This function validates each field of xml based on _xmlTypeMAP object.
/// This object is global and is defined inside of each html file.
/// </summary>

/// <param name="xmlObject">XML object. In this function the xml content is updated.</param>
/// <returns name="xmlObject">return the xmlObject modified.</returns>
function xmlContentFiltering(xmlObject) 
{
    var xmlNodes = $(xmlObject).find("*");
    var length = xmlNodes.length;
    
    // For each node, store the current index. Used to identify when a structure of tags is repeated 
    var indexMap = {};
    
    // Structure of tags counter
    var structureTagsIndex = -1;
    
    // The first node (root) must not be considered and the index have to start in 1" 
    for (var i=1; i < length; i++)
    {
        var currentNode = xmlNodes[i];
        var errorCheckresult = false;
        var typeCheckresult = false;
        // If is a valid node...
        if (isValidTag(currentNode)) 
        {
            var nodeName  = currentNode.nodeName; 
            var nodeValue = $(currentNode).text();
            
            // If there isn't the node name on index map....
            if (indexMap[nodeName] == null)
            {
                // Add the node name to index map starting with -1. 
                indexMap[nodeName] = -1;
            }
            // Increment the node current index on map
            indexMap[nodeName]++;
            
            var currentIndexNode = indexMap[nodeName];
            
            // Any error ocurred in writing XML file (Server Side Error)
            if (errorContentValidation(nodeValue))
            {
                xmlObject = updateContentNode(xmlObject, 
                                              nodeName, 
                                              currentIndexNode, 
                                              getPromptTableValue(nodeValue));
            }
            // Check the content (type validation and convertions)
            else
            {
                typeCheckresult = typeValidation(currentNode);
                // If had any problem with type checking...
                if (!typeCheckresult)
                {
                    xmlObject = updateContentNode(xmlObject, 
                                                  nodeName, 
                                                  currentIndexNode, 
                                                  getPromptTableValue(ERROR_XML_DATATYPE));
                }
                // If had no problem with type checking, checks if any content transformation is needed
                else
                {
                    nodeValue = nodeContentConversion(currentNode, getCurrentLanguage())
                    
                    if (nodeValue != null)
                    {
                        // Set xml node content with the content modified
                        xmlObject = updateContentNode(xmlObject, 
                                                      nodeName, 
                                                      currentIndexNode, 
                                                      nodeValue);
                        
                    }
                }
            }
        }
    }
    // Returns the main manipulated xml
    return xmlObject;
}

/// PRIVATE
/// <summary>
/// Check the content node comparing with default values ('status_error' or 'status_na').
/// </summary>

/// <param name="contentNode">String object</param>
/// <returns name="typeCheckresult">true/false. Returns true if the content node match with any 
///  default value.</returns>
function errorContentValidation(contentNode)
{
    // Normalizing the content to comparison
    contentNode = contentNode.toLowerCase();
    var STATUS_ERROR = 'status_error';
    var STATUS_NA    = 'status_na'
    return contentNode === STATUS_ERROR || contentNode === STATUS_NA;
}

/// PRIVATE
/// <summary>
/// Check the content node using the type specified on _xmlTypeMAP (type map for each html file)
/// </summary>

/// <param name="currentNode">XML object. In this function the xml content isn't updated.</param>
/// <returns name="typeCheckresult">true/false. Returns true if have no problem with the 
/// type validation.</returns>
function typeValidation(currentNode)
{
    var typeCheckresult = true;
    var nodeName  = currentNode.nodeName; 
    var nodeValue = $(currentNode).text();
    
    // Get the node properties on _xmlTypeMAP object
    var element = _xmlTypeMAP[nodeName];
    if (element != null)
    {       
        // Get the filter element. May be a string array or a function 
        var filter = element.filter;
        if (filter != null)
        {
            // Checks the type of element mapping data is a Array
            if (filter.constructor == Array)
            {
                // Check if there is a nodeValue in filter string array
                typeCheckresult = filter.contains(nodeValue);
            }
            // Checks the type of element mapping data is a Function.
            else if (filter.constructor == Function)
            {
                // Invokes the filter function passing the arguments array
                // and return the result of filter validation.
                typeCheckresult = filter.apply(null, [nodeValue]);
            }
        }
    }
    return typeCheckresult;
}

/// PRIVATE
/// <summary>
/// Checks that had conversion for the current node value...
/// </summary>

/// <param name="currentNode">XML object. In this function the xml content is updated.</param>
/// <param name="idiom">current idiom. Used for translation the enumeration content</param>
/// <returns name="newNodeValue">new content or null.</returns>
function nodeContentConversion(currentNode, idiom)
{
    var newNodeValue = null;
    var nodeName  = currentNode.nodeName; 
    var nodeValue = $(currentNode).text();
    // If there is the unit attribute, get it
    var attrUnit = $(currentNode).attr('unit');
    
    // Verify if the value is a duration type to convert if true
    if (isDurationType(nodeValue))
    {
        newNodeValue = convertToDuration(nodeValue);
    }
    else if (isDateTime(nodeValue))
    {
        newNodeValue = convertDateTimeToString(nodeValue);
    }
    // Translate (if applicable) the tag value
    else if (isEnumTagValue(nodeName))
    {
        newNodeValue = getPromptTableValue(nodeValue);
    }else if (multiLangText(nodeValue, true))
	{
		newNodeValue = getPromptTableValue(multiLangText(nodeValue, false));
    }
    // Verify if the node have the attribute unit
    if (attrUnit != null)
    {
        newNodeValue = newNodeValue != null ? newNodeValue : nodeValue;
        // Put the value of unity at the end of the node content
        newNodeValue += attrUnit;
    }
    return newNodeValue;
}

/// <summary>
/// Update content in a specific xml node. 
/// </summary>
///
/// <param name="xmlObject">Object XML</param>
/// <param name="nodeName"></param>
/// <param name="index"></param>
/// <param name="content"></param>
/// <return>xml updated - xmlObject</return>
function updateContentNode(xmlObject, nodeName, index, content)
{   
    var elementsArray = xmlObject.getElementsByTagName(nodeName);
    // If the index does not exceed the bounds of the getElementsByTagName array....
    if ( (index >= 0) && (index < elementsArray.length) )
    {
        // If the element exist....
        if (elementsArray[index].childNodes.length > 0)
        {
            xmlObject
                .getElementsByTagName(nodeName)[index]
                .childNodes[0]
                .nodeValue = content;
        }
        // If the element there isn't it is created
        else
        {
            var newChild = xmlObject.createTextNode("element");
            newChild.nodeValue = content;
            xmlObject
                .getElementsByTagName(nodeName)[index]
                .appendChild(newChild);
        }
    }
    return xmlObject;
}


/// <summary>
/// Functions - Data Type Validation. 
/// </summary>
///
/// <param name="value">input string value</param>
/// <return>true/false</return>

function isDateTime(value)
{
    // timestamp considered: "2008-05-30T09:00:07"
    
    //   year     month       day       hour       minute     second
    // |------| |--------| |--------| |--------| |--------| |--------|
    //  \d{4}  -   \d{2}  -   \d{2}  T   \d{2}  :   \d{2}  :   \d{2}
    var result = ((value).match(DATE_TIME_REGULAR_EXPRESSION) != null);
    
    if (result)
    {
        var dateTime = value.split('T');
        var date = dateTime[0];
        var time = dateTime[1];
        result = ((date).match(DATE_REGULAR_EXPRESSION) != null) &&
                 ((time).match(TIME_REGULAR_EXPRESSION) != null);
    }
    
    return result;
}

function isDuration(value)
{
    return isDurationType(value);
}

function isContent(value)
{
    // verify only if there is at least one character
    if (value.trim().length == 0) return false;
    return true;
}

function isInteger(value) 
{
    return ((value).match(INTEGER_REGULAR_EXPRESSION) != null);
}

function isPositiveInteger(value)
{
    var result = false;
    try
    {
        result = (isNonNegativeInteger(value) && (parseInt(value,10) != 0));
    }
    catch(e)
    {
    }
    return result;
}

function isNonNegativeInteger(value) 
{
    return ((value).match(NON_NEGATIVE_INTEGER_REGULAR_EXPRESSION) != null);
}

function isDecimal(value) 
{
    return ((value).match(DECIMAL_REGULAR_EXPRESSION) != null);
}

function isBoolean(value)
{
    var uppercaseValue = value.toUpperCase();
    if (uppercaseValue == "TRUE" || uppercaseValue == "FALSE") return true;
    return false;
}

function isIPv4Address(value)
{
	return (IPV4_ADDRESS_REGULAR_EXPRESSION.test(value));
}

function isIPv6Address(value)
{
	return (IPV6_ADDRESS_REGULAR_EXPRESSION.test(value));
}

function isFQDN(value)
{
	return (FQDN_REGULAR_EXPRESSION.test(value));
}

function isHostName(hname)
{
	if(hname.length<3 || hname.length>32)
		return false;

	for(var j=0; j<hname.length; j++)
	{
		var dh = hname.charAt(j);
		var hh = dh.charCodeAt(0);
		if((hh > 47 && hh<58) || (hh > 64 && hh<91) || (hh > 96 && hh<123) || hh==45)
		{
			if((j==0 || j==hname.length-1) && hh == 45)	
			{
				return false;
			}
		}else
		{
			return false;
		}
	}
	return true;
}

/* CBN -  20130910 - Gary - add for KD requirement */
function isSubnetMask(subnetmask)
{
	var value = subnetmask.split('.');
	var i,j;
	
	for(i=0;i<4;i++)
	{
		if(value[i] < 0 || value[i] > 255)
			return false;
		
		if(value[i] < 255){
			for(j=i+1;j<4;j++)
			{
				if(value[j] != 0)
					return false;
			}
		}
	}
	
	return true;
}


function isDomainName(hname)
{
	if(hname.length<3 || hname.length>64)
		return false;

	for(var j=0; j<hname.length; j++)
	{
		var dh = hname.charAt(j);
		var hh = dh.charCodeAt(0);
		if((hh > 47 && hh<58) || (hh > 64 && hh<91) || (hh > 96 && hh<123) || hh==45 || hh==46)
		{
			if((j==0 || j==hname.length-1) && hh == 45)	
			{
				return false;
			}
		}else
		{
			return false;
		}
	}
	return true;
}

function isPortNumber(port)
{
	if(!isPositiveInteger(port) || parseInt(port, 10)>65535)
		return false
	return true;
}

/*CBN_S: Andy*/
function btnRestartCM(){
	var sUrlServer = urlLocation() + '/setRestartCM.html';
	var data;

    try {
       $.ajax({url: sUrlServer,
            type: 'POST',
			async: false,
            data: data,
            error: function(){
                showErrorMessage('#form-config');
            }
       });
    }
    catch (e)
    {
       alert('CableModem - ' + e.message);
    }
	//location.reload();
}

function btnResetALLtoDefaults(){
	var sUrlServer = urlLocation() + '/setResetAllDefaults.html';
	var data;

    try {
       $.ajax({url: sUrlServer,
            type: 'POST',
			async: false,
            data: data,
            error: function(){
                showErrorMessage('#form-config');
            }
       });
    }
    catch (e)
    {
       alert('CableModem - ' + e.message);
    }
	//location.reload();
}

function fakehtml(){
	var sUrlServer = urlLocation() + '/fake.html';
	var data;

    try {
       $.ajax({url: sUrlServer,
            type: 'POST',
			async: false,
            data: data,
            error: function(){
                showErrorMessage('#form-config');
            }
       });
    }
    catch (e)
    {
       alert('CableModem - ' + e.message);
    }
	//location.reload();
}

function setCMConfig(action){
	
	var sUrlServer = urlLocation() + '/setCMConfig.html';
	var instance;
	var tmp;
	
	var freq1 = $('#favorite-frequency').val();
	var freq2 = $('#favorite-frequency2').val();
	var freq3 = $('#favorite-frequency3').val();
	
	if(_CustomerId == "kdg")
	{
		if( (freq1=="" || (!isNaN(freq1) && parseInt(freq1,10) <= 1002 && parseInt(freq1,10) >= 50)) && (freq2=="" || (!isNaN(freq2) && parseInt(freq2,10) <= 1002 && parseInt(freq2,10) >= 50)) && (freq3=="" || (!isNaN(freq3) && parseInt(freq3,10) <= 1002 && parseInt(freq3,10) >= 50)) )
		{

		tmp = $('#div-frequency-plan').find('input,select').serialize();
		tmp += "&"+$('#div-channelid').find('input,select').serialize();
		tmp += "&"+$('#div-favorite-frequency').find('input,select').serialize();
		tmp += "&"+$('#div-favorite-frequency2').find('input,select').serialize();
		tmp += "&"+$('#div-favorite-frequency3').find('input,select').serialize();
		tmp += "&"+$('#div-hybridmode').find('input,select').serialize();
	
		//org
		//ajaxSyncReq(sUrlServer,tmp);
		//location.reload();

		}
		else
		{
			alert("Exceed downstream frequency range limit!!");
			return;
		}
	}
	else
	{
	if( (freq1=="" || (!isNaN(freq1) && parseInt(freq1,10) <= 1002000000 && parseInt(freq1,10) >= 50000000)) && (freq2=="" || (!isNaN(freq2) && parseInt(freq2,10) <= 1002000000 && parseInt(freq2,10) >= 50000000)) && (freq3=="" || (!isNaN(freq3) && parseInt(freq3,10) <= 1002000000 && parseInt(freq3,10) >= 50000000)) )
  {

	tmp = $('#div-frequency-plan').find('input,select').serialize();
	tmp += "&"+$('#div-channelid').find('input,select').serialize();
	tmp += "&"+$('#div-favorite-frequency').find('input,select').serialize();
	tmp += "&"+$('#div-favorite-frequency2').find('input,select').serialize();
	tmp += "&"+$('#div-favorite-frequency3').find('input,select').serialize();
	tmp += "&"+$('#div-hybridmode').find('input,select').serialize();
	
	//org
	//ajaxSyncReq(sUrlServer,tmp);
	//location.reload();

	}
	else
	{
	alert("Exceed downstream frequency range limit!!");
		return;
	}
	}
	ajaxSyncReq(sUrlServer,tmp);

	if(_serverAlert == 1)
		return;
	
	location.reload();
	
}
/*CBN_E: Andy*/

// =================================================================================================
// 
// Redefining methods
// 
// =================================================================================================

// Removing elements on Array String objects according to the value
Array.prototype.removeByElement = function(value)
{
    for (var i=0 in this) {
        if (this[i] == value)
        {
            this.splice(i,1); 
        }
    }
}

// Implments the contains method for Array String objects
Array.prototype.contains = function ( value ) {
    if (typeof(value) != "string")
    {
        return false;
    }
    value = value.toLowerCase();
    for (var i=0 in this) {
        var element = this[i];
        if (typeof(element) == "string" && element.toLowerCase() == value) return true;
    }
    return false;
}

// Implments the trim method for String objects
String.prototype.trim = function()
{
    return this.replace(/^\s*/, "").replace(/\s*$/, "");
}

/* CBN20110413 wilson add start */
function multiLangText(engText, checkOnly)
{
	/* 
	format: { str: "this string need to be translate", id : "string_id"}
	*/
	var multiLangStrings = [
		{ str: "[Empty String]", id: "id_common_empty_str" },
		{ str: "Unsupported OID", id: "voice_prov_err_001" },
		{ str: "English", id: "id_common_lang01" },
		{ str: "Spanish", id: "id_common_lang02" },
		{ str: "German", id: "id_common_lang03" },
		{ str: "Chinese", id: "id_common_lang04" },
		{ str: "China", id: "id_common_lang05" },
		{ str: "Nederland", id: "id_common_lang06" },
		{ str: "France", id: "id_common_lang07" },
		{ str: "tcp", id: "tcp" },
		{ str: "udp", id: "udp" }
	];
	
	for (var i = 0; i < multiLangStrings.length; i++) {
		if(engText == multiLangStrings[i].str)
		{
			if(checkOnly)
				return true;
			return multiLangStrings[i].id;
		}
	}
	return false;
}
/* CBN20110413 wilson add end */
/* CBN_S - 20110712 - Anderson */
function convertSecondsToDurationString(seconds)
{
    var strDuration = '';
    var Day    = 0;
    var Hour   = 0;
    var Minute = 0;
    var Second = 0;

    Second = seconds % 60;
    strDuration = Second+'s';
    if((seconds -= Second)<=0)
    	return strDuration;

    Minute = seconds % 3600;
    strDuration = (Minute/60)+'m'+strDuration;
    if((seconds -= Minute)<=0)
    	return strDuration;

    Hour = seconds % 86400;
    strDuration = (Hour/3600)+'h'+strDuration;
    if((seconds -= Hour)<=0)
    	return strDuration;

    Day = seconds/86400;
    strDuration = Day+getPromptTableValue('message_duration_days')+strDuration;

    return strDuration;
}
/* CBN_E - 20110712 - Anderson */
/* CBN_S - 20110822 - Anderson */
function getIPv6AddrPrefix(strIp6Addr, intIp6PrefixLen)
{
	var Ip6Addr = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	var Ip6Mask = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	var Ip6Prefix = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	var strIp6Prefix="";
	
	var tmp = strIp6Addr.split(":", 8);
	var zero_item = 8-tmp.length;
	for(var i=0, j=0; i<8 && j<8; i++, j++)
	{
		if(tmp[i]==""){
			j+=zero_item;
			continue;
		}
		Ip6Addr[j] = parseInt(tmp[i], 16);
	}

	var bit_count = intIp6PrefixLen;
	for(var i=0; i<8; i++)
	{
		if(bit_count<16)
		{
			Ip6Mask[i]=(Math.pow(2, bit_count)-1)<<(16-bit_count);
			break;
		}
		else
		{
			Ip6Mask[i]=0xffff;
			bit_count-=16;
		}
	}

	for(var i=0; i<8; i++)
		Ip6Prefix[i] = Ip6Addr[i] & Ip6Mask[i];

	strIp6Prefix += (Ip6Prefix[0]==0) ? "" : Ip6Prefix[0].toString(16);
	var stateCompress = 0;
	for(var i=1; i<8; i++)
	{
		if(Ip6Prefix[i]==0){
			if(stateCompress==0){
				stateCompress=1;
				strIp6Prefix += ":";
			}else if(stateCompress==1){
				if(i==7)
					strIp6Prefix += ":";
			}else if(stateCompress==2){
				strIp6Prefix += ":"+Ip6Prefix[i].toString(16);
			}
		}else{
			if(stateCompress==1){
				stateCompress=2;
			}
			strIp6Prefix += ":"+Ip6Prefix[i].toString(16);
		}
	}

	return strIp6Prefix;
}
/* CBN_E - 20110822 - Anderson */
/* CBN_S - 20110916 */
function compareIPv6Addr(strIp6Addr1, strIp6Addr2)
{
	var Ip6Addr1 = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	var Ip6Addr2 = new Array(0, 0, 0, 0, 0, 0, 0, 0);
	var tmp, zero_item;
	
	tmp = strIp6Addr1.split(":", 8);
	zero_item = 8-tmp.length;
	for(var i=0, j=0; i<8 && j<8; i++, j++)
	{
		if(tmp[i]==""){
			j+=zero_item;
			continue;
		}
		Ip6Addr1[j] = parseInt(tmp[i], 16);
	}
	
	tmp = strIp6Addr2.split(":", 8);
	zero_item = 8-tmp.length;
	for(var i=0, j=0; i<8 && j<8; i++, j++)
	{
		if(tmp[i]==""){
			j+=zero_item;
			continue;
		}
		Ip6Addr2[j] = parseInt(tmp[i], 16);
	}
	
	for(var i=0; i<8; i++)
	{
		if(Ip6Addr1[i]<Ip6Addr2[i])
			return -1;
		else if(Ip6Addr1[i]>Ip6Addr2[i])
			return 1;
	}
	
	return 0;
}
/* CBN_E - 20110916 */
